#!/bin/bash

# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


if [ ! -e "${RANGER_HOME}"/.setupDone ]
then
  SETUP_RMS=true
else
  SETUP_RMS=false
fi

if [ "${SETUP_RMS}" == "true" ]
then
  su -c "cd ${RANGER_HOME}/rangerrms && ./setup.sh" rangerrms

  touch "${RANGER_HOME}"/.setupDone
fi

su -c "cat <<EOF > \"${RANGER_HOME}\"/rangerrms/ews/webapp/WEB-INF/classes/conf/ranger-rms-env-bin.sh
export BIN_PATH=/opt/ranger/rangerrms
export LINUX_USER=rangerrms
EOF" rangerrms

su -c "chmod a+rx /opt/ranger/rangerrms/ews/webapp/WEB-INF/classes/conf/ranger-rms-env-bin.sh" rangerrms

cd "${RANGER_HOME}"/rangerrms && ./ranger-rms-services.sh start

# prevent the container from exiting | below is configured from log4j.properties
tail -f "${RMS_HOME}"/ews/logs/ranger-rms-$(hostname)-rangerrms.log