#!/bin/bash
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# -------------------------------------------------------------------------------------


#Setup input vars for policy migration
####### Export operations ############

#Source Ranger admin url with protocol and port
export POLICYMGR_EXTERNAL_URL=http://localhost:6080
export POLICYMGR_KERBEROS_ENABLED=false
#if Source Ranger-admin is ssh enabled then set below property to true else false
export POLICYMGR_HTTPS_ENABLED=false
#if Source Ranger-admin is ssh enabled then provide the certificate file path
export POLICYMGR_HTTPS_CERT_FILE=
#if Source Ranger-admin is knoxsso enabled then provide the knox sso token value
export POLICYMGR_KNOXSSO_TOKEN=

#Source ranger-admin user name which has admin privileges 
export POLICYMGR_ADMIN=
#Source ranger-admin password of the user provided above
export POLICYMGR_PWD=

#Source ranger-admin service names of which policies need to be exported, by default all service policies will be exported
export SOURCE_SERVICE_NAME=
#export SOURCE_ZONE_NAME=

#output file name(json format only) or parent directory path where Ranger policies needs to be exported.
export EXPORT_OUTPUT_LOCATION=

####### Transform operation ############

export PYTHON_COMMAND_INVOKER=python

#service type names of which ranger policies need to be excluded from the exported ranger policy json file
export RANGER_POLICYMIGRATION_EXCLUDE_SERVICE_TYPES=storm,tag
#ranger service type mapping of which ranger policy need to be transformed to target service type
export SOURCE_DESTINATION_RANGER_SERVICE_TYPE_MAPPING='{hdfs:s3}'
#ranger service name mappings so that source ranger service name can be transformed to target ranger service name
export SOURCE_DESTINATION_RANGER_SERVICE_NAME_MAPPING=

#users mapping file in csv or json format to replace user names in ranger policy
export RANGER_POLICYMIGRATION_USERS_MAPPING_FILE=
#resource mapping file in csv or json format to replace policy resources entry in ranger policy
export RANGER_POLICYMIGRATION_RESOURCE_MAPPING_FILE=
#hive url mapping file in csv or json format to replace hive policy urls entry in ranger policy
export RANGER_POLICYMIGRATION_HIVE_URL_MAPPING_FILE=

#S3 bucket name for ranger hdfs policies which need to be transformed to s3 policy
export S3_BUCKET_NAME=
#export ADLS_STORAGE_ACCOUNT=
#export ADLS_STORAGE_ACCOUNT_CONTAINER=

#output file name(json format only) or parent directory path where file needs to be generated.
export RANGER_POLICYMIGRATION_TRANSFORM_OUTPUT_FILE=

# to convert native hdfs policy to ranger policy, provide the target ranger hdfs service name
export SERVICE_NAME_FOR_NATIVE_POLICIES=cm_hdfs
# Prefix for generated ranger hdfs policies created from Native hdfs permissions 
export POLICY_NAME_PREFIX_FOR_NATIVE_POLICIES=
# Description for generated ranger hdfs policies created from Native hdfs permissions 
export POLICY_DESCRIPTION_FOR_NATIVE_POLICIES=


# #################  DO NOT MODIFY ANY VARIABLES BELOW #########################
#
# --- These deployment variables are not to be modified unless you understand the full impact of the changes
#
################################################################################
export RANGER_POLICYMIGRATION_LOG_DIR=$PWD/logs
export POLICYMIGRATION_INSTALL_DIR=$PWD
export LOGFILE=ranger-policymigration.log
export LOGFILES={$LOGFILE}

export JAVA_VERSION_REQUIRED='1.8'
export RANGER_POLICYMIGRATION_MAX_HEAP_SIZE=4g

export UNIX_USER=ranger
export UNIX_USER_PWD=ranger
export UNIX_GROUP=ranger
