#!/bin/bash
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# -------------------------------------------------------------------------------------

max=1
userMax=5
groupNamePrefix=testgroup
userNamePrefix=test
serviceName=service_hbase
policyNamePrefix=$serviceName
databaseNamePrefix=table
tableName1Prefix=cfA
tableName2Prefix=cfB
tableName3Prefix=cfC
colNamePrefix=columnA

START=$(date +%s)

for (( i=1; i <= $max; i++ ))
do
  currentTime=$(date +%s%N)
  userName="$userNamePrefix"_"$i"
  policyName="$policyNamePrefix"_"$i"
  databaseName="$databaseNamePrefix"_"$i"
  tableName1="$tableName1Prefix"_"$i"
  tableName2="$tableName2Prefix"_"$i"
  tableName3="$tableName3Prefix"_"$i"
  colName="$colNamePrefix"_"$i"
  groupName="$groupNamePrefix"_"$i"
  usersList=''\"$userNamePrefix\"''
  for (( j=1; j <= $userMax; j++ ))
  do
    tempVar="$userName"_user_"$j"
    usersList+=', '\"$tempVar\"''
  done
  #echo $usersList
  userJSON='{"policyType":"0","name":'\"$policyName\"',"isEnabled":true,"policyPriority":0,"policyLabels":[],"description":"","isAuditEnabled":true,"resources":{"table":{"values":['\"$databaseName\"'],"isRecursive":false,"isExcludes":false},"column-family":{"values":['\"$tableName1\"','\"$tableName2\"','\"$tableName3\"'],"isRecursive":false,"isExcludes":false},"column":{"values":['\"$colName\"'],"isRecursive":false,"isExcludes":false}},"isDenyAllElse":false,"policyItems":[{"groups":['\"$groupName\"'],"users":['"$usersList"'],"accesses":[{"type":"read","isAllowed":true}, {"type":"create","isAllowed":true}, {"type":"execute","isAllowed":true}]}],"allowExceptions":[],"denyPolicyItems":[],"denyExceptions":[],"service":'\"$serviceName\"'}'
  echo $userJSON
  curl -k --header Accept:application/json -H Content-Type:application/json -X POST 'http://localhost:6080/service/plugins/policies' -u admin:admin123 -d "$userJSON"
done

END=$(date +%s)
DIFF=$(( $END - $START ))
echo "It took $DIFF seconds"