#!/bin/bash
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# -------------------------------------------------------------------------------------
## sample entry => "/dir1/file2, /dir1/file11"|"testuser1, testuser2"|"testgroup1, testgroup2"|"read, write"
#set -x
max=50000
userMax=5
groupNamePrefix=testgroup
userNamePrefix=test
serviceName=service_hdfs
policyNamePrefix=$serviceName
databaseNamePrefix=/dir
tableName1Prefix=/folder
tableName2Prefix=/file.txt
tableName3Prefix=/.hidden.txt
colNamePrefix=col1
permissions="read, write, execute"

START=$(date +%s)

fileName=${PWD}/sample_native_hdfs_permissions_${max}.csv
echo -n "" > $fileName

for (( i=1; i <= $max; i++ ))
do
  currentTime=$(date +%s%N)
  userName="$userNamePrefix"_"$i"
  policyName="$policyNamePrefix"_"$i"
  databaseName="$databaseNamePrefix"_"$i"
  tableName1=$tableName1Prefix
  tableName2=$tableName2Prefix
  tableName3=$tableName3Prefix
  colName="$colNamePrefix"_"$i"
  groupName="$groupNamePrefix"_"$i"
  usersList=$userNamePrefix
  for (( j=1; j <= $userMax; j++ ))
  do
    tempVar="$userName"_user_"$j"
    usersList+=", $tempVar"
  done
  resource="$databaseName$tableName1, $databaseName$tableName2, $databaseName$tableName3"
  echo "\"${resource}\" | \"${usersList}\" | \"${groupName}\" | \"${permissions}\""  >> $fileName
done
END=$(date +%s)
DIFF=$(( $END - $START ))
echo "It took $DIFF seconds"