/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.ranger.policymigration.reader;

import java.util.List;

public class NativeAclPolicy {
    private List<String> resourcePaths;
    private List<String> users;
    private List<String> groups;
    private List<String> permissions;

    public NativeAclPolicy() {
    	this(null, null, null, null);
    }
    
    public NativeAclPolicy(List<String> resources, List<String> users, List<String> groups, List<String> permissions) {
    	this.resourcePaths = resources;
    	this.users = users;
    	this.groups = groups;
    	this.permissions = permissions;
    }

	public List<String> getResourcePaths() {
		return resourcePaths;
	}

	public void setResourcePaths(List<String> resourcePaths) {
		this.resourcePaths = resourcePaths;
	}

	public List<String> getUsers() {
		return users;
	}

	public void setUsers(List<String> users) {
		this.users = users;
	}

	public List<String> getGroups() {
		return groups;
	}

	public void setGroups(List<String> groups) {
		this.groups = groups;
	}

	public List<String> getPermissions() {
		return permissions;
	}

	public void setPermissions(List<String> permissions) {
		this.permissions = permissions;
	}

	public String toString( ) {
		String str = "RawAccessPolicy={";
		str += "resourcePaths={" + resourcePaths + "} ";
		str += "users={" + users + "} ";
		str += "groups={" + groups + "} ";
		str += "permissions={" + permissions + "} ";
		str += "}";
		return str;
	}
}
