/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.ranger.raz.hook.s3;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.s3a.auth.AwsSignerInitializer;
import org.apache.hadoop.fs.s3a.auth.delegation.DelegationTokenProvider;
import org.apache.hadoop.security.UserGroupInformation;

public class RazS3SignerPluginInitializer implements AwsSignerInitializer {

  private static final Logger LOG = LoggerFactory.getLogger(
      org.apache.ranger.raz.hook.s3.RazS3SignerPluginInitializer.class);

  @Override
  public void registerStore(String bucketName, Configuration storeConf,
      DelegationTokenProvider dtProvider, UserGroupInformation storeUgi) {
    if (LOG.isTraceEnabled()) {
      LOG.trace("registerStore with dtProvider.hashCode={}, bucketName={}, ugi.hashCode={}",
          dtProvider.hashCode(), bucketName, storeUgi.hashCode());
    }
  }

  @Override
  public void unregisterStore(String bucketName, Configuration storeConf,
      DelegationTokenProvider dtProvider, UserGroupInformation storeUgi) {

    if (LOG.isTraceEnabled()) {
      LOG.trace("unregisterStore with dtProvider.hashCode={}, bucketName={}, ugi.hashCode={}",
          dtProvider.hashCode(), bucketName, storeUgi.hashCode());
    }
  }
}
