/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.ranger.raz.intg.client.executor;

import javax.net.ssl.SSLContext;

public class RestClientExecutorConfig {
    private boolean    ssl;
    private SSLContext sslContext;
    private String     username;
    private String     password;
    private Integer    restClientConnTimeOutMs;
    private Integer    restClientReadTimeOutMs;
    private Integer    maxConnections;
    private Integer    maxConnectionsPerHost;
    private Integer    validateAfterInactivityMs;
    private Integer    poolRetryCount;
    private String     jwtEnvVarName;
    private String     jwtFileName;
    private String     jwtTokenRetrieverClass;
    private String     jwtServerCookieName;

    public boolean isSsl() {
        return ssl;
    }

    public void setSsl(boolean ssl) {
        this.ssl = ssl;
    }

    public SSLContext getSslContext() {
        return sslContext;
    }

    public void setSslContext(SSLContext sslContext) {
        this.sslContext = sslContext;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public Integer getRestClientConnTimeOutMs() {
        return restClientConnTimeOutMs;
    }

    public void setRestClientConnTimeOutMs(Integer restClientConnTimeOutMs) {
        this.restClientConnTimeOutMs = restClientConnTimeOutMs;
    }

    public Integer getRestClientReadTimeOutMs() {
        return restClientReadTimeOutMs;
    }

    public void setRestClientReadTimeOutMs(Integer restClientReadTimeOutMs) {
        this.restClientReadTimeOutMs = restClientReadTimeOutMs;
    }

    public Integer getMaxConnections() {
        return maxConnections;
    }

    public void setMaxConnections(Integer maxConnections) {
        this.maxConnections = maxConnections;
    }

    public Integer getMaxConnectionsPerHost() {
        return maxConnectionsPerHost;
    }

    public void setMaxConnectionsPerHost(Integer maxConnectionsPerHost) {
        this.maxConnectionsPerHost = maxConnectionsPerHost;
    }

    public Integer getValidateAfterInactivityMs() {
        return validateAfterInactivityMs;
    }

    public void setValidateAfterInactivityMs(Integer validateAfterInactivityMs) {
        this.validateAfterInactivityMs = validateAfterInactivityMs;
    }

    public Integer getPoolRetryCount() {
        return poolRetryCount;
    }

    public void setPoolRetryCount(Integer poolRetryCount) {
        this.poolRetryCount = poolRetryCount;
    }

    public String getJwtEnvVarName() {
        return this.jwtEnvVarName;
    }

    public void setJwtEnvVarName(String jwtEnvVarName) {
        this.jwtEnvVarName = jwtEnvVarName;
    }

    public String getJwtFileName() {
        return this.jwtFileName;
    }

    public void setJwtFileName(String jwtFileName) {
        this.jwtFileName = jwtFileName;
    }

    public String getJwtTokenRetrieverClass() {
        return this.jwtTokenRetrieverClass;
    }

    public void setJwtTokenRetrieverClass(String jwtTokenRetrieverClass) {
        this.jwtTokenRetrieverClass = jwtTokenRetrieverClass;
    }

    public String getJwtServerCookieName() {
        return this.jwtServerCookieName;
    }

    public void setJwtServerCookieName(String jwtServerCookieName) {
        this.jwtServerCookieName = jwtServerCookieName;
    }

    private void toString(StringBuilder sb) {
        sb.append("RestClientExecutorConfig [ssl=");
        sb.append(ssl);
        sb.append(", username=");
        sb.append(username);
        sb.append(", restClientConnTimeOutMs=");
        sb.append(restClientConnTimeOutMs);
        sb.append(", restClientReadTimeOutMs=");
        sb.append(restClientReadTimeOutMs);
        sb.append(", maxConnections=");
        sb.append(maxConnections);
        sb.append(", maxConnectionsPerHost=");
        sb.append(maxConnectionsPerHost);
        sb.append(", validateAfterInactivityMs=");
        sb.append(validateAfterInactivityMs);
        sb.append(", poolRetryCount=");
        sb.append(poolRetryCount);
        sb.append("]");
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        toString(sb);

        return sb.toString();
    }
}
