/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.ranger.raz.model;

import java.util.Map;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;

import org.codehaus.jackson.annotate.JsonAutoDetect;
import org.codehaus.jackson.annotate.JsonIgnoreProperties;
import org.codehaus.jackson.annotate.JsonAutoDetect.Visibility;
import org.codehaus.jackson.map.annotate.JsonSerialize;

@JsonAutoDetect(fieldVisibility=Visibility.ANY)
@JsonSerialize(include=JsonSerialize.Inclusion.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown=true)
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class RangerRazIdentityMappings {
	private Long                version;
	private Map<String, String> userClusterIdToCloudId;
	private Map<String, String> groupClusterIdToCloudId;

	public Long getVersion() {
		return version;
	}

	public void setVersion(Long version) {
		this.version = version;
	}

	public Map<String, String> getUserClusterIdToCloudId() {
		return userClusterIdToCloudId;
	}

	public void setUserClusterIdToCloudId(Map<String, String> userClusterIdToCloudId) {
		this.userClusterIdToCloudId = userClusterIdToCloudId;
	}

	public Map<String, String> getGroupClusterIdToCloudId() {
		return groupClusterIdToCloudId;
	}

	public void setGroupClusterIdToCloudId(Map<String, String> groupClusterIdToCloudId) {
		this.groupClusterIdToCloudId = groupClusterIdToCloudId;
	}

	@Override
	public String toString() {
		return "RangerRazUserIdentityMappings [version=" + version + ", userClusterIdToCloudId="
				+ userClusterIdToCloudId + ", groupClusterIdToCloudId=" + groupClusterIdToCloudId + "]";
	}
}
