/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.ranger.raz.s3.lib;

/**
 * Class which contains different RangerRazException headers to translate
 * RangerRazException into an AmazonServiceException.
 */
public class RangerRazExceptionS3Headers {

  /** RangerRazException header for S3 error code. */
  public static final String AWS_ERROR_CODE = "x-ranger-amz-error-code";

  /** RangerRazException header for S3 status code. */
  public static final String AWS_STATUS_CODE = "x-ranger-amz-status-code";

  /** RangerRazException header for S3 request id. */
  public static final String AWS_REQUEST_ID = "x-ranger-amz-request-id";

  /** RangerRazException header for S3 extended request id. */
  public static final String AWS_EXTENDED_REQUEST_ID = "x-ranger-amz-id-2";

}
