/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.ranger.raz.s3.lib;

public class RazS3Constants {

  // TODO Ideally replace this with a Context class which provides the request id,
  //  instead of piggybacking on MDC
  public static final String MDC_REQUEST_ID = "request.id";

  public static final String S3LIB_PERF_TRACKER_ENABLED = "rcs.perf.tracker.enabled";

  // TODO Make this accessible in Knox
  public static final String KNOX_S3_IDB_TOKEN_KIND = "S3ADelegationToken/IDBroker";

  public static final String HEADER_USER_AGENT = "User-Agent";

  // TODO: Send back a message with a reason for a DENY/UNKNOWN
  public enum AuthorizationStatus {
    ALLOW, DENY, UNDEFINED
  }

  public enum AccessType {
    READ, WRITE, EXECUTE
  }
}
