/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.ranger.raz.s3.lib.perflogger;

import org.apache.ranger.raz.s3.lib.perflogger.PerfLogger.PerfLoggerInterface;

/**
 * No-op implementation of the perf tracker, for when it is disabled
 */
public class PerfLoggerNoOpImpl implements PerfLoggerInterface {

  private static final PerfLoggerNoOpImpl INSTANCE = new PerfLoggerNoOpImpl();

  private PerfLoggerNoOpImpl() {
  }

  public static PerfLoggerInterface get() {
    return INSTANCE;
  }

  @Override
  public void opBegin(String context, String opName) {

  }

  @Override
  public long opEnd(String context, String opName) {
    return -1;
  }
}
