/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.ranger.raz.s3.lib.authorizer.impl;

/**
 * Tests Ranger policy enforcement based on the policies defined in src/test/resources/s3signer_s3repo.json.
 * At the moment, these represent the default policies defined under
 * src/main/resources/default-ranger-policies.
 *
 * The test reads the raner-s3-security.xml config file under src/test/resources and ends up using
 * RangerClientImplForTest to set up the policies for the Authorizer.
 *
 * At the moment, {@link RangerConfiguration} is a singleton. As a result, it is difficult to write
 * multiple tests with different sets of policy files.
 */
public class TestCloudStorageAuthorizer extends CloudStorageAuthorizerTestBase {
  // TODO
}
