/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.ranger.raz.processor.s3.signer;

public class S3RazConstants {
  public static final String S3_SERVICE_NAME_DEFAULT = "cm_s3";

  public static final String RANGER_RAZ_SERVICE_TYPE_S3_DEFAULT_SERVICE_NAME
      = "ranger.raz.service.type.s3.default.service.name";
  public static final String RANGER_RAZ_VALID_SAS_API_VERSION
      = "ranger.raz.valid.sas.api.version";

  /**
   * Number of seconds prior to aws credential expiry to
   * trigger a new aws credential request.
   * Value : {@value}
   */
  public static final String RANGER_RAZ_AWS_CREDENTIAL_EXPIRY_OFFSET_SECONDS =
          "ranger.raz.aws.credential.expiry.offset.seconds";

  public static final int RANGER_RAZ_AWS_CREDENTIAL_EXPIRY_OFFSET_SECONDS_DEFAULT = 5 * 60;

  /**
   * Number of seconds prior to idBroker token expiry to
   * trigger renewal of the idBroker token.
   * Value : {@value}
   */
  public static final String RANGER_RAZ_IDB_CREDENTIAL_EXPIRY_OFFSET_SECONDS =
          "ranger.raz.idb.credential.expiry.offset.seconds";

  public static final int RANGER_RAZ_IDB_CREDENTIAL_EXPIRY_OFFSET_SECONDS_DEFAULT =  5 * 60;
}
