/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

 /*
 *
 */
package org.apache.ranger.common;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.TimeZone;

import org.springframework.stereotype.Component;

@Component
public class DateUtil {

    private static final TimeZone gmtTimeZone = TimeZone.getTimeZone("GMT+0");


	public static Date getUTCDate(){
		try{
			Calendar local=Calendar.getInstance();
		    int offset = local.getTimeZone().getOffset(local.getTimeInMillis());
		    GregorianCalendar utc = new GregorianCalendar(gmtTimeZone);
		    utc.setTimeInMillis(local.getTimeInMillis());
		    utc.add(Calendar.MILLISECOND, -offset);
		    return utc.getTime();
		}catch(Exception ex){
			return null;
		}
	}

	public static Date getUTCDate(long epoh) {
		if(epoh==0){
			return null;
		}
		try{
			Calendar local=Calendar.getInstance();
		    int offset = local.getTimeZone().getOffset(epoh);
		    GregorianCalendar utc = new GregorianCalendar(gmtTimeZone);
		    utc.setTimeInMillis(epoh);
		    utc.add(Calendar.MILLISECOND, -offset);	
		    return utc.getTime();
	    }catch(Exception ex){
	    	return null;
	    }	    		
	}

}
