/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.ranger.raz.s3.lib.signer.protos;

public final class SignerProtocolProtos {
  private SignerProtocolProtos() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  /**
   * Protobuf enum {@code org.apache.ranger.raz.s3.lib.signer.HttpMethodProto}
   */
  public enum HttpMethodProto
      implements com.google.protobuf.ProtocolMessageEnum {
    /**
     * <code>DEFAULT = 0;</code>
     */
    DEFAULT(0, 0),
    /**
     * <code>GET = 1;</code>
     */
    GET(1, 1),
    /**
     * <code>POST = 2;</code>
     */
    POST(2, 2),
    /**
     * <code>PUT = 3;</code>
     */
    PUT(3, 3),
    /**
     * <code>DELETE = 4;</code>
     */
    DELETE(4, 4),
    /**
     * <code>HEAD = 5;</code>
     */
    HEAD(5, 5),
    ;

    /**
     * <code>DEFAULT = 0;</code>
     */
    public static final int DEFAULT_VALUE = 0;
    /**
     * <code>GET = 1;</code>
     */
    public static final int GET_VALUE = 1;
    /**
     * <code>POST = 2;</code>
     */
    public static final int POST_VALUE = 2;
    /**
     * <code>PUT = 3;</code>
     */
    public static final int PUT_VALUE = 3;
    /**
     * <code>DELETE = 4;</code>
     */
    public static final int DELETE_VALUE = 4;
    /**
     * <code>HEAD = 5;</code>
     */
    public static final int HEAD_VALUE = 5;


    public final int getNumber() { return value; }

    public static HttpMethodProto valueOf(int value) {
      switch (value) {
        case 0: return DEFAULT;
        case 1: return GET;
        case 2: return POST;
        case 3: return PUT;
        case 4: return DELETE;
        case 5: return HEAD;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<HttpMethodProto>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static com.google.protobuf.Internal.EnumLiteMap<HttpMethodProto>
        internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<HttpMethodProto>() {
            public HttpMethodProto findValueByNumber(int number) {
              return HttpMethodProto.valueOf(number);
            }
          };

    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      return getDescriptor().getValues().get(index);
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.getDescriptor().getEnumTypes().get(0);
    }

    private static final HttpMethodProto[] VALUES = values();

    public static HttpMethodProto valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      return VALUES[desc.getIndex()];
    }

    private final int index;
    private final int value;

    private HttpMethodProto(int index, int value) {
      this.index = index;
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:org.apache.ranger.raz.s3.lib.signer.HttpMethodProto)
  }

  /**
   * Protobuf enum {@code org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto}
   */
  public enum ResponseCodeProto
      implements com.google.protobuf.ProtocolMessageEnum {
    /**
     * <code>AUTHZ_AUTHORIZED = 0;</code>
     */
    AUTHZ_AUTHORIZED(0, 0),
    /**
     * <code>AUTHZ_UNAUTHORIZED = 1;</code>
     */
    AUTHZ_UNAUTHORIZED(1, 1),
    /**
     * <code>AUTHZ_UNKNOWN = 2;</code>
     */
    AUTHZ_UNKNOWN(2, 2),
    /**
     * <code>ERROR = 3;</code>
     */
    ERROR(3, 3),
    ;

    /**
     * <code>AUTHZ_AUTHORIZED = 0;</code>
     */
    public static final int AUTHZ_AUTHORIZED_VALUE = 0;
    /**
     * <code>AUTHZ_UNAUTHORIZED = 1;</code>
     */
    public static final int AUTHZ_UNAUTHORIZED_VALUE = 1;
    /**
     * <code>AUTHZ_UNKNOWN = 2;</code>
     */
    public static final int AUTHZ_UNKNOWN_VALUE = 2;
    /**
     * <code>ERROR = 3;</code>
     */
    public static final int ERROR_VALUE = 3;


    public final int getNumber() { return value; }

    public static ResponseCodeProto valueOf(int value) {
      switch (value) {
        case 0: return AUTHZ_AUTHORIZED;
        case 1: return AUTHZ_UNAUTHORIZED;
        case 2: return AUTHZ_UNKNOWN;
        case 3: return ERROR;
        default: return null;
      }
    }

    public static com.google.protobuf.Internal.EnumLiteMap<ResponseCodeProto>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static com.google.protobuf.Internal.EnumLiteMap<ResponseCodeProto>
        internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<ResponseCodeProto>() {
            public ResponseCodeProto findValueByNumber(int number) {
              return ResponseCodeProto.valueOf(number);
            }
          };

    public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      return getDescriptor().getValues().get(index);
    }
    public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.getDescriptor().getEnumTypes().get(1);
    }

    private static final ResponseCodeProto[] VALUES = values();

    public static ResponseCodeProto valueOf(
        com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      return VALUES[desc.getIndex()];
    }

    private final int index;
    private final int value;

    private ResponseCodeProto(int index, int value) {
      this.index = index;
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto)
  }

  public interface StringStringMapProtoOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional string key = 1;
    /**
     * <code>optional string key = 1;</code>
     */
    boolean hasKey();
    /**
     * <code>optional string key = 1;</code>
     */
    String getKey();
    /**
     * <code>optional string key = 1;</code>
     */
    com.google.protobuf.ByteString
        getKeyBytes();

    // optional string value = 2;
    /**
     * <code>optional string value = 2;</code>
     */
    boolean hasValue();
    /**
     * <code>optional string value = 2;</code>
     */
    String getValue();
    /**
     * <code>optional string value = 2;</code>
     */
    com.google.protobuf.ByteString
        getValueBytes();
  }
  /**
   * Protobuf type {@code org.apache.ranger.raz.s3.lib.signer.StringStringMapProto}
   */
  public static final class StringStringMapProto extends
      com.google.protobuf.GeneratedMessage
      implements StringStringMapProtoOrBuilder {
    // Use StringStringMapProto.newBuilder() to construct.
    private StringStringMapProto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private StringStringMapProto(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final StringStringMapProto defaultInstance;
    public static StringStringMapProto getDefaultInstance() {
      return defaultInstance;
    }

    public StringStringMapProto getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private StringStringMapProto(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              key_ = input.readBytes();
              break;
            }
            case 18: {
              bitField0_ |= 0x00000002;
              value_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_StringStringMapProto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_StringStringMapProto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.class, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder.class);
    }

    public static com.google.protobuf.Parser<StringStringMapProto> PARSER =
        new com.google.protobuf.AbstractParser<StringStringMapProto>() {
      public StringStringMapProto parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new StringStringMapProto(input, extensionRegistry);
      }
    };

    @Override
    public com.google.protobuf.Parser<StringStringMapProto> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // optional string key = 1;
    public static final int KEY_FIELD_NUMBER = 1;
    private Object key_;
    /**
     * <code>optional string key = 1;</code>
     */
    public boolean hasKey() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional string key = 1;</code>
     */
    public String getKey() {
      Object ref = key_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          key_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string key = 1;</code>
     */
    public com.google.protobuf.ByteString
        getKeyBytes() {
      Object ref = key_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        key_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string value = 2;
    public static final int VALUE_FIELD_NUMBER = 2;
    private Object value_;
    /**
     * <code>optional string value = 2;</code>
     */
    public boolean hasValue() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional string value = 2;</code>
     */
    public String getValue() {
      Object ref = value_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          value_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string value = 2;</code>
     */
    public com.google.protobuf.ByteString
        getValueBytes() {
      Object ref = value_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        value_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private void initFields() {
      key_ = "";
      value_ = "";
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, getKeyBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(2, getValueBytes());
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, getKeyBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, getValueBytes());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @Override
    protected Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    @Override
    public boolean equals(final Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto)) {
        return super.equals(obj);
      }
      org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto other = (org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto) obj;

      boolean result = true;
      result = result && (hasKey() == other.hasKey());
      if (hasKey()) {
        result = result && getKey()
            .equals(other.getKey());
      }
      result = result && (hasValue() == other.hasValue());
      if (hasValue()) {
        result = result && getValue()
            .equals(other.getValue());
      }
      result = result &&
          getUnknownFields().equals(other.getUnknownFields());
      return result;
    }

    private int memoizedHashCode = 0;
    @Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptorForType().hashCode();
      if (hasKey()) {
        hash = (37 * hash) + KEY_FIELD_NUMBER;
        hash = (53 * hash) + getKey().hashCode();
      }
      if (hasValue()) {
        hash = (37 * hash) + VALUE_FIELD_NUMBER;
        hash = (53 * hash) + getValue().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code org.apache.ranger.raz.s3.lib.signer.StringStringMapProto}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_StringStringMapProto_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_StringStringMapProto_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.class, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder.class);
      }

      // Construct using org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        key_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        value_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_StringStringMapProto_descriptor;
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto getDefaultInstanceForType() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.getDefaultInstance();
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto build() {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto buildPartial() {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto result = new org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.key_ = key_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.value_ = value_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto) {
          return mergeFrom((org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto other) {
        if (other == org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.getDefaultInstance()) return this;
        if (other.hasKey()) {
          bitField0_ |= 0x00000001;
          key_ = other.key_;
          onChanged();
        }
        if (other.hasValue()) {
          bitField0_ |= 0x00000002;
          value_ = other.value_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional string key = 1;
      private Object key_ = "";
      /**
       * <code>optional string key = 1;</code>
       */
      public boolean hasKey() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional string key = 1;</code>
       */
      public String getKey() {
        Object ref = key_;
        if (!(ref instanceof String)) {
          String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          key_ = s;
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>optional string key = 1;</code>
       */
      public com.google.protobuf.ByteString
          getKeyBytes() {
        Object ref = key_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          key_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string key = 1;</code>
       */
      public Builder setKey(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        key_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string key = 1;</code>
       */
      public Builder clearKey() {
        bitField0_ = (bitField0_ & ~0x00000001);
        key_ = getDefaultInstance().getKey();
        onChanged();
        return this;
      }
      /**
       * <code>optional string key = 1;</code>
       */
      public Builder setKeyBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        key_ = value;
        onChanged();
        return this;
      }

      // optional string value = 2;
      private Object value_ = "";
      /**
       * <code>optional string value = 2;</code>
       */
      public boolean hasValue() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>optional string value = 2;</code>
       */
      public String getValue() {
        Object ref = value_;
        if (!(ref instanceof String)) {
          String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          value_ = s;
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>optional string value = 2;</code>
       */
      public com.google.protobuf.ByteString
          getValueBytes() {
        Object ref = value_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          value_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string value = 2;</code>
       */
      public Builder setValue(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        value_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string value = 2;</code>
       */
      public Builder clearValue() {
        bitField0_ = (bitField0_ & ~0x00000002);
        value_ = getDefaultInstance().getValue();
        onChanged();
        return this;
      }
      /**
       * <code>optional string value = 2;</code>
       */
      public Builder setValueBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        value_ = value;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:org.apache.ranger.raz.s3.lib.signer.StringStringMapProto)
    }

    static {
      defaultInstance = new StringStringMapProto(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:org.apache.ranger.raz.s3.lib.signer.StringStringMapProto)
  }

  public interface StringListStringMapProtoOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional string key = 1;
    /**
     * <code>optional string key = 1;</code>
     */
    boolean hasKey();
    /**
     * <code>optional string key = 1;</code>
     */
    String getKey();
    /**
     * <code>optional string key = 1;</code>
     */
    com.google.protobuf.ByteString
        getKeyBytes();

    // repeated string value = 2;
    /**
     * <code>repeated string value = 2;</code>
     */
    java.util.List<String>
    getValueList();
    /**
     * <code>repeated string value = 2;</code>
     */
    int getValueCount();
    /**
     * <code>repeated string value = 2;</code>
     */
    String getValue(int index);
    /**
     * <code>repeated string value = 2;</code>
     */
    com.google.protobuf.ByteString
        getValueBytes(int index);
  }
  /**
   * Protobuf type {@code org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto}
   */
  public static final class StringListStringMapProto extends
      com.google.protobuf.GeneratedMessage
      implements StringListStringMapProtoOrBuilder {
    // Use StringListStringMapProto.newBuilder() to construct.
    private StringListStringMapProto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private StringListStringMapProto(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final StringListStringMapProto defaultInstance;
    public static StringListStringMapProto getDefaultInstance() {
      return defaultInstance;
    }

    public StringListStringMapProto getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private StringListStringMapProto(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              key_ = input.readBytes();
              break;
            }
            case 18: {
              if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
                value_ = new com.google.protobuf.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000002;
              }
              value_.add(input.readBytes());
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
          value_ = new com.google.protobuf.UnmodifiableLazyStringList(value_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_StringListStringMapProto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_StringListStringMapProto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.class, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder.class);
    }

    public static com.google.protobuf.Parser<StringListStringMapProto> PARSER =
        new com.google.protobuf.AbstractParser<StringListStringMapProto>() {
      public StringListStringMapProto parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new StringListStringMapProto(input, extensionRegistry);
      }
    };

    @Override
    public com.google.protobuf.Parser<StringListStringMapProto> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // optional string key = 1;
    public static final int KEY_FIELD_NUMBER = 1;
    private Object key_;
    /**
     * <code>optional string key = 1;</code>
     */
    public boolean hasKey() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional string key = 1;</code>
     */
    public String getKey() {
      Object ref = key_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          key_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string key = 1;</code>
     */
    public com.google.protobuf.ByteString
        getKeyBytes() {
      Object ref = key_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        key_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // repeated string value = 2;
    public static final int VALUE_FIELD_NUMBER = 2;
    private com.google.protobuf.LazyStringList value_;
    /**
     * <code>repeated string value = 2;</code>
     */
    public java.util.List<String>
        getValueList() {
      return value_;
    }
    /**
     * <code>repeated string value = 2;</code>
     */
    public int getValueCount() {
      return value_.size();
    }
    /**
     * <code>repeated string value = 2;</code>
     */
    public String getValue(int index) {
      return value_.get(index);
    }
    /**
     * <code>repeated string value = 2;</code>
     */
    public com.google.protobuf.ByteString
        getValueBytes(int index) {
      return value_.getByteString(index);
    }

    private void initFields() {
      key_ = "";
      value_ = com.google.protobuf.LazyStringArrayList.EMPTY;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, getKeyBytes());
      }
      for (int i = 0; i < value_.size(); i++) {
        output.writeBytes(2, value_.getByteString(i));
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, getKeyBytes());
      }
      {
        int dataSize = 0;
        for (int i = 0; i < value_.size(); i++) {
          dataSize += com.google.protobuf.CodedOutputStream
            .computeBytesSizeNoTag(value_.getByteString(i));
        }
        size += dataSize;
        size += 1 * getValueList().size();
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @Override
    protected Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    @Override
    public boolean equals(final Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto)) {
        return super.equals(obj);
      }
      org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto other = (org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto) obj;

      boolean result = true;
      result = result && (hasKey() == other.hasKey());
      if (hasKey()) {
        result = result && getKey()
            .equals(other.getKey());
      }
      result = result && getValueList()
          .equals(other.getValueList());
      result = result &&
          getUnknownFields().equals(other.getUnknownFields());
      return result;
    }

    private int memoizedHashCode = 0;
    @Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptorForType().hashCode();
      if (hasKey()) {
        hash = (37 * hash) + KEY_FIELD_NUMBER;
        hash = (53 * hash) + getKey().hashCode();
      }
      if (getValueCount() > 0) {
        hash = (37 * hash) + VALUE_FIELD_NUMBER;
        hash = (53 * hash) + getValueList().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProtoOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_StringListStringMapProto_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_StringListStringMapProto_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.class, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder.class);
      }

      // Construct using org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        key_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        value_ = com.google.protobuf.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_StringListStringMapProto_descriptor;
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto getDefaultInstanceForType() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.getDefaultInstance();
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto build() {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto buildPartial() {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto result = new org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.key_ = key_;
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          value_ = new com.google.protobuf.UnmodifiableLazyStringList(
              value_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.value_ = value_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto) {
          return mergeFrom((org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto other) {
        if (other == org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.getDefaultInstance()) return this;
        if (other.hasKey()) {
          bitField0_ |= 0x00000001;
          key_ = other.key_;
          onChanged();
        }
        if (!other.value_.isEmpty()) {
          if (value_.isEmpty()) {
            value_ = other.value_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureValueIsMutable();
            value_.addAll(other.value_);
          }
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional string key = 1;
      private Object key_ = "";
      /**
       * <code>optional string key = 1;</code>
       */
      public boolean hasKey() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional string key = 1;</code>
       */
      public String getKey() {
        Object ref = key_;
        if (!(ref instanceof String)) {
          String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          key_ = s;
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>optional string key = 1;</code>
       */
      public com.google.protobuf.ByteString
          getKeyBytes() {
        Object ref = key_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          key_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string key = 1;</code>
       */
      public Builder setKey(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        key_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string key = 1;</code>
       */
      public Builder clearKey() {
        bitField0_ = (bitField0_ & ~0x00000001);
        key_ = getDefaultInstance().getKey();
        onChanged();
        return this;
      }
      /**
       * <code>optional string key = 1;</code>
       */
      public Builder setKeyBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        key_ = value;
        onChanged();
        return this;
      }

      // repeated string value = 2;
      private com.google.protobuf.LazyStringList value_ = com.google.protobuf.LazyStringArrayList.EMPTY;
      private void ensureValueIsMutable() {
        if (!((bitField0_ & 0x00000002) == 0x00000002)) {
          value_ = new com.google.protobuf.LazyStringArrayList(value_);
          bitField0_ |= 0x00000002;
         }
      }
      /**
       * <code>repeated string value = 2;</code>
       */
      public java.util.List<String>
          getValueList() {
        return java.util.Collections.unmodifiableList(value_);
      }
      /**
       * <code>repeated string value = 2;</code>
       */
      public int getValueCount() {
        return value_.size();
      }
      /**
       * <code>repeated string value = 2;</code>
       */
      public String getValue(int index) {
        return value_.get(index);
      }
      /**
       * <code>repeated string value = 2;</code>
       */
      public com.google.protobuf.ByteString
          getValueBytes(int index) {
        return value_.getByteString(index);
      }
      /**
       * <code>repeated string value = 2;</code>
       */
      public Builder setValue(
          int index, String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureValueIsMutable();
        value_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string value = 2;</code>
       */
      public Builder addValue(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureValueIsMutable();
        value_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string value = 2;</code>
       */
      public Builder addAllValue(
          Iterable<String> values) {
        ensureValueIsMutable();
        super.addAll(values, value_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string value = 2;</code>
       */
      public Builder clearValue() {
        value_ = com.google.protobuf.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string value = 2;</code>
       */
      public Builder addValueBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureValueIsMutable();
        value_.add(value);
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto)
    }

    static {
      defaultInstance = new StringListStringMapProto(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto)
  }

  public interface AuthorizationResponseProtoOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;</code>
     */
    boolean hasResponseCode();
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;</code>
     */
    org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto getResponseCode();

    // repeated string unauthorized_paths = 2;
    /**
     * <code>repeated string unauthorized_paths = 2;</code>
     */
    java.util.List<String>
    getUnauthorizedPathsList();
    /**
     * <code>repeated string unauthorized_paths = 2;</code>
     */
    int getUnauthorizedPathsCount();
    /**
     * <code>repeated string unauthorized_paths = 2;</code>
     */
    String getUnauthorizedPaths(int index);
    /**
     * <code>repeated string unauthorized_paths = 2;</code>
     */
    com.google.protobuf.ByteString
        getUnauthorizedPathsBytes(int index);

    // optional string response_message = 3;
    /**
     * <code>optional string response_message = 3;</code>
     */
    boolean hasResponseMessage();
    /**
     * <code>optional string response_message = 3;</code>
     */
    String getResponseMessage();
    /**
     * <code>optional string response_message = 3;</code>
     */
    com.google.protobuf.ByteString
        getResponseMessageBytes();
  }
  /**
   * Protobuf type {@code org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto}
   */
  public static final class AuthorizationResponseProto extends
      com.google.protobuf.GeneratedMessage
      implements AuthorizationResponseProtoOrBuilder {
    // Use AuthorizationResponseProto.newBuilder() to construct.
    private AuthorizationResponseProto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private AuthorizationResponseProto(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final AuthorizationResponseProto defaultInstance;
    public static AuthorizationResponseProto getDefaultInstance() {
      return defaultInstance;
    }

    public AuthorizationResponseProto getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private AuthorizationResponseProto(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 8: {
              int rawValue = input.readEnum();
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto value = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(1, rawValue);
              } else {
                bitField0_ |= 0x00000001;
                responseCode_ = value;
              }
              break;
            }
            case 18: {
              if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
                unauthorizedPaths_ = new com.google.protobuf.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000002;
              }
              unauthorizedPaths_.add(input.readBytes());
              break;
            }
            case 26: {
              bitField0_ |= 0x00000002;
              responseMessage_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
          unauthorizedPaths_ = new com.google.protobuf.UnmodifiableLazyStringList(unauthorizedPaths_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_AuthorizationResponseProto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_AuthorizationResponseProto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.class, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.Builder.class);
    }

    public static com.google.protobuf.Parser<AuthorizationResponseProto> PARSER =
        new com.google.protobuf.AbstractParser<AuthorizationResponseProto>() {
      public AuthorizationResponseProto parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new AuthorizationResponseProto(input, extensionRegistry);
      }
    };

    @Override
    public com.google.protobuf.Parser<AuthorizationResponseProto> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;
    public static final int RESPONSE_CODE_FIELD_NUMBER = 1;
    private org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto responseCode_;
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;</code>
     */
    public boolean hasResponseCode() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;</code>
     */
    public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto getResponseCode() {
      return responseCode_;
    }

    // repeated string unauthorized_paths = 2;
    public static final int UNAUTHORIZED_PATHS_FIELD_NUMBER = 2;
    private com.google.protobuf.LazyStringList unauthorizedPaths_;
    /**
     * <code>repeated string unauthorized_paths = 2;</code>
     */
    public java.util.List<String>
        getUnauthorizedPathsList() {
      return unauthorizedPaths_;
    }
    /**
     * <code>repeated string unauthorized_paths = 2;</code>
     */
    public int getUnauthorizedPathsCount() {
      return unauthorizedPaths_.size();
    }
    /**
     * <code>repeated string unauthorized_paths = 2;</code>
     */
    public String getUnauthorizedPaths(int index) {
      return unauthorizedPaths_.get(index);
    }
    /**
     * <code>repeated string unauthorized_paths = 2;</code>
     */
    public com.google.protobuf.ByteString
        getUnauthorizedPathsBytes(int index) {
      return unauthorizedPaths_.getByteString(index);
    }

    // optional string response_message = 3;
    public static final int RESPONSE_MESSAGE_FIELD_NUMBER = 3;
    private Object responseMessage_;
    /**
     * <code>optional string response_message = 3;</code>
     */
    public boolean hasResponseMessage() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional string response_message = 3;</code>
     */
    public String getResponseMessage() {
      Object ref = responseMessage_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          responseMessage_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string response_message = 3;</code>
     */
    public com.google.protobuf.ByteString
        getResponseMessageBytes() {
      Object ref = responseMessage_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        responseMessage_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private void initFields() {
      responseCode_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto.AUTHZ_AUTHORIZED;
      unauthorizedPaths_ = com.google.protobuf.LazyStringArrayList.EMPTY;
      responseMessage_ = "";
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeEnum(1, responseCode_.getNumber());
      }
      for (int i = 0; i < unauthorizedPaths_.size(); i++) {
        output.writeBytes(2, unauthorizedPaths_.getByteString(i));
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(3, getResponseMessageBytes());
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(1, responseCode_.getNumber());
      }
      {
        int dataSize = 0;
        for (int i = 0; i < unauthorizedPaths_.size(); i++) {
          dataSize += com.google.protobuf.CodedOutputStream
            .computeBytesSizeNoTag(unauthorizedPaths_.getByteString(i));
        }
        size += dataSize;
        size += 1 * getUnauthorizedPathsList().size();
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(3, getResponseMessageBytes());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @Override
    protected Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    @Override
    public boolean equals(final Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto)) {
        return super.equals(obj);
      }
      org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto other = (org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto) obj;

      boolean result = true;
      result = result && (hasResponseCode() == other.hasResponseCode());
      if (hasResponseCode()) {
        result = result &&
            (getResponseCode() == other.getResponseCode());
      }
      result = result && getUnauthorizedPathsList()
          .equals(other.getUnauthorizedPathsList());
      result = result && (hasResponseMessage() == other.hasResponseMessage());
      if (hasResponseMessage()) {
        result = result && getResponseMessage()
            .equals(other.getResponseMessage());
      }
      result = result &&
          getUnknownFields().equals(other.getUnknownFields());
      return result;
    }

    private int memoizedHashCode = 0;
    @Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptorForType().hashCode();
      if (hasResponseCode()) {
        hash = (37 * hash) + RESPONSE_CODE_FIELD_NUMBER;
        hash = (53 * hash) + hashEnum(getResponseCode());
      }
      if (getUnauthorizedPathsCount() > 0) {
        hash = (37 * hash) + UNAUTHORIZED_PATHS_FIELD_NUMBER;
        hash = (53 * hash) + getUnauthorizedPathsList().hashCode();
      }
      if (hasResponseMessage()) {
        hash = (37 * hash) + RESPONSE_MESSAGE_FIELD_NUMBER;
        hash = (53 * hash) + getResponseMessage().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProtoOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_AuthorizationResponseProto_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_AuthorizationResponseProto_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.class, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.Builder.class);
      }

      // Construct using org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        responseCode_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto.AUTHZ_AUTHORIZED;
        bitField0_ = (bitField0_ & ~0x00000001);
        unauthorizedPaths_ = com.google.protobuf.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        responseMessage_ = "";
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_AuthorizationResponseProto_descriptor;
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto getDefaultInstanceForType() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.getDefaultInstance();
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto build() {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto buildPartial() {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto result = new org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.responseCode_ = responseCode_;
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          unauthorizedPaths_ = new com.google.protobuf.UnmodifiableLazyStringList(
              unauthorizedPaths_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.unauthorizedPaths_ = unauthorizedPaths_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000002;
        }
        result.responseMessage_ = responseMessage_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto) {
          return mergeFrom((org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto other) {
        if (other == org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.getDefaultInstance()) return this;
        if (other.hasResponseCode()) {
          setResponseCode(other.getResponseCode());
        }
        if (!other.unauthorizedPaths_.isEmpty()) {
          if (unauthorizedPaths_.isEmpty()) {
            unauthorizedPaths_ = other.unauthorizedPaths_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureUnauthorizedPathsIsMutable();
            unauthorizedPaths_.addAll(other.unauthorizedPaths_);
          }
          onChanged();
        }
        if (other.hasResponseMessage()) {
          bitField0_ |= 0x00000004;
          responseMessage_ = other.responseMessage_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;
      private org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto responseCode_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto.AUTHZ_AUTHORIZED;
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;</code>
       */
      public boolean hasResponseCode() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto getResponseCode() {
        return responseCode_;
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;</code>
       */
      public Builder setResponseCode(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto value) {
        if (value == null) {
          throw new NullPointerException();
        }
        bitField0_ |= 0x00000001;
        responseCode_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.ResponseCodeProto response_code = 1;</code>
       */
      public Builder clearResponseCode() {
        bitField0_ = (bitField0_ & ~0x00000001);
        responseCode_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.ResponseCodeProto.AUTHZ_AUTHORIZED;
        onChanged();
        return this;
      }

      // repeated string unauthorized_paths = 2;
      private com.google.protobuf.LazyStringList unauthorizedPaths_ = com.google.protobuf.LazyStringArrayList.EMPTY;
      private void ensureUnauthorizedPathsIsMutable() {
        if (!((bitField0_ & 0x00000002) == 0x00000002)) {
          unauthorizedPaths_ = new com.google.protobuf.LazyStringArrayList(unauthorizedPaths_);
          bitField0_ |= 0x00000002;
         }
      }
      /**
       * <code>repeated string unauthorized_paths = 2;</code>
       */
      public java.util.List<String>
          getUnauthorizedPathsList() {
        return java.util.Collections.unmodifiableList(unauthorizedPaths_);
      }
      /**
       * <code>repeated string unauthorized_paths = 2;</code>
       */
      public int getUnauthorizedPathsCount() {
        return unauthorizedPaths_.size();
      }
      /**
       * <code>repeated string unauthorized_paths = 2;</code>
       */
      public String getUnauthorizedPaths(int index) {
        return unauthorizedPaths_.get(index);
      }
      /**
       * <code>repeated string unauthorized_paths = 2;</code>
       */
      public com.google.protobuf.ByteString
          getUnauthorizedPathsBytes(int index) {
        return unauthorizedPaths_.getByteString(index);
      }
      /**
       * <code>repeated string unauthorized_paths = 2;</code>
       */
      public Builder setUnauthorizedPaths(
          int index, String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureUnauthorizedPathsIsMutable();
        unauthorizedPaths_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string unauthorized_paths = 2;</code>
       */
      public Builder addUnauthorizedPaths(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureUnauthorizedPathsIsMutable();
        unauthorizedPaths_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string unauthorized_paths = 2;</code>
       */
      public Builder addAllUnauthorizedPaths(
          Iterable<String> values) {
        ensureUnauthorizedPathsIsMutable();
        super.addAll(values, unauthorizedPaths_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string unauthorized_paths = 2;</code>
       */
      public Builder clearUnauthorizedPaths() {
        unauthorizedPaths_ = com.google.protobuf.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string unauthorized_paths = 2;</code>
       */
      public Builder addUnauthorizedPathsBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureUnauthorizedPathsIsMutable();
        unauthorizedPaths_.add(value);
        onChanged();
        return this;
      }

      // optional string response_message = 3;
      private Object responseMessage_ = "";
      /**
       * <code>optional string response_message = 3;</code>
       */
      public boolean hasResponseMessage() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>optional string response_message = 3;</code>
       */
      public String getResponseMessage() {
        Object ref = responseMessage_;
        if (!(ref instanceof String)) {
          String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          responseMessage_ = s;
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>optional string response_message = 3;</code>
       */
      public com.google.protobuf.ByteString
          getResponseMessageBytes() {
        Object ref = responseMessage_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          responseMessage_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string response_message = 3;</code>
       */
      public Builder setResponseMessage(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        responseMessage_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string response_message = 3;</code>
       */
      public Builder clearResponseMessage() {
        bitField0_ = (bitField0_ & ~0x00000004);
        responseMessage_ = getDefaultInstance().getResponseMessage();
        onChanged();
        return this;
      }
      /**
       * <code>optional string response_message = 3;</code>
       */
      public Builder setResponseMessageBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        responseMessage_ = value;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto)
    }

    static {
      defaultInstance = new AuthorizationResponseProto(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto)
  }

  public interface SignRequestProtoOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional string endpoint = 1;
    /**
     * <code>optional string endpoint = 1;</code>
     */
    boolean hasEndpoint();
    /**
     * <code>optional string endpoint = 1;</code>
     */
    String getEndpoint();
    /**
     * <code>optional string endpoint = 1;</code>
     */
    com.google.protobuf.ByteString
        getEndpointBytes();

    // optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;</code>
     */
    boolean hasHttpMethod();
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;</code>
     */
    org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto getHttpMethod();

    // repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
     */
    java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto>
        getHeadersList();
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
     */
    org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto getHeaders(int index);
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
     */
    int getHeadersCount();
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
     */
    java.util.List<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder>
        getHeadersOrBuilderList();
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
     */
    org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder getHeadersOrBuilder(
        int index);

    // repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
     */
    java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto>
        getParametersList();
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
     */
    org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto getParameters(int index);
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
     */
    int getParametersCount();
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
     */
    java.util.List<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProtoOrBuilder>
        getParametersOrBuilderList();
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
     */
    org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProtoOrBuilder getParametersOrBuilder(
        int index);

    // optional bytes content_to_sign = 5;
    /**
     * <code>optional bytes content_to_sign = 5;</code>
     */
    boolean hasContentToSign();
    /**
     * <code>optional bytes content_to_sign = 5;</code>
     */
    com.google.protobuf.ByteString getContentToSign();

    // optional string resource_path = 6;
    /**
     * <code>optional string resource_path = 6;</code>
     */
    boolean hasResourcePath();
    /**
     * <code>optional string resource_path = 6;</code>
     */
    String getResourcePath();
    /**
     * <code>optional string resource_path = 6;</code>
     */
    com.google.protobuf.ByteString
        getResourcePathBytes();

    // optional int32 time_offset = 7;
    /**
     * <code>optional int32 time_offset = 7;</code>
     *
     * <pre>
     * The following may not be required.
     * </pre>
     */
    boolean hasTimeOffset();
    /**
     * <code>optional int32 time_offset = 7;</code>
     *
     * <pre>
     * The following may not be required.
     * </pre>
     */
    int getTimeOffset();

    // optional string endpoint_prefix = 8;
    /**
     * <code>optional string endpoint_prefix = 8;</code>
     */
    boolean hasEndpointPrefix();
    /**
     * <code>optional string endpoint_prefix = 8;</code>
     */
    String getEndpointPrefix();
    /**
     * <code>optional string endpoint_prefix = 8;</code>
     */
    com.google.protobuf.ByteString
        getEndpointPrefixBytes();

    // optional string service_name = 9;
    /**
     * <code>optional string service_name = 9;</code>
     */
    boolean hasServiceName();
    /**
     * <code>optional string service_name = 9;</code>
     */
    String getServiceName();
    /**
     * <code>optional string service_name = 9;</code>
     */
    com.google.protobuf.ByteString
        getServiceNameBytes();
  }
  /**
   * Protobuf type {@code org.apache.ranger.raz.s3.lib.signer.SignRequestProto}
   */
  public static final class SignRequestProto extends
      com.google.protobuf.GeneratedMessage
      implements SignRequestProtoOrBuilder {
    // Use SignRequestProto.newBuilder() to construct.
    private SignRequestProto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private SignRequestProto(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final SignRequestProto defaultInstance;
    public static SignRequestProto getDefaultInstance() {
      return defaultInstance;
    }

    public SignRequestProto getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private SignRequestProto(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              endpoint_ = input.readBytes();
              break;
            }
            case 16: {
              int rawValue = input.readEnum();
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto value = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(2, rawValue);
              } else {
                bitField0_ |= 0x00000002;
                httpMethod_ = value;
              }
              break;
            }
            case 26: {
              if (!((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
                headers_ = new java.util.ArrayList<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto>();
                mutable_bitField0_ |= 0x00000004;
              }
              headers_.add(input.readMessage(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.PARSER, extensionRegistry));
              break;
            }
            case 34: {
              if (!((mutable_bitField0_ & 0x00000008) == 0x00000008)) {
                parameters_ = new java.util.ArrayList<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto>();
                mutable_bitField0_ |= 0x00000008;
              }
              parameters_.add(input.readMessage(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.PARSER, extensionRegistry));
              break;
            }
            case 42: {
              bitField0_ |= 0x00000004;
              contentToSign_ = input.readBytes();
              break;
            }
            case 50: {
              bitField0_ |= 0x00000008;
              resourcePath_ = input.readBytes();
              break;
            }
            case 56: {
              bitField0_ |= 0x00000010;
              timeOffset_ = input.readInt32();
              break;
            }
            case 66: {
              bitField0_ |= 0x00000020;
              endpointPrefix_ = input.readBytes();
              break;
            }
            case 74: {
              bitField0_ |= 0x00000040;
              serviceName_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
          headers_ = java.util.Collections.unmodifiableList(headers_);
        }
        if (((mutable_bitField0_ & 0x00000008) == 0x00000008)) {
          parameters_ = java.util.Collections.unmodifiableList(parameters_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_SignRequestProto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_SignRequestProto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto.class, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto.Builder.class);
    }

    public static com.google.protobuf.Parser<SignRequestProto> PARSER =
        new com.google.protobuf.AbstractParser<SignRequestProto>() {
      public SignRequestProto parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new SignRequestProto(input, extensionRegistry);
      }
    };

    @Override
    public com.google.protobuf.Parser<SignRequestProto> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // optional string endpoint = 1;
    public static final int ENDPOINT_FIELD_NUMBER = 1;
    private Object endpoint_;
    /**
     * <code>optional string endpoint = 1;</code>
     */
    public boolean hasEndpoint() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional string endpoint = 1;</code>
     */
    public String getEndpoint() {
      Object ref = endpoint_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          endpoint_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string endpoint = 1;</code>
     */
    public com.google.protobuf.ByteString
        getEndpointBytes() {
      Object ref = endpoint_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        endpoint_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;
    public static final int HTTP_METHOD_FIELD_NUMBER = 2;
    private org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto httpMethod_;
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;</code>
     */
    public boolean hasHttpMethod() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;</code>
     */
    public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto getHttpMethod() {
      return httpMethod_;
    }

    // repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;
    public static final int HEADERS_FIELD_NUMBER = 3;
    private java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto> headers_;
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
     */
    public java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto> getHeadersList() {
      return headers_;
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
     */
    public java.util.List<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder>
        getHeadersOrBuilderList() {
      return headers_;
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
     */
    public int getHeadersCount() {
      return headers_.size();
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
     */
    public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto getHeaders(int index) {
      return headers_.get(index);
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
     */
    public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder getHeadersOrBuilder(
        int index) {
      return headers_.get(index);
    }

    // repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;
    public static final int PARAMETERS_FIELD_NUMBER = 4;
    private java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto> parameters_;
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
     */
    public java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto> getParametersList() {
      return parameters_;
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
     */
    public java.util.List<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProtoOrBuilder>
        getParametersOrBuilderList() {
      return parameters_;
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
     */
    public int getParametersCount() {
      return parameters_.size();
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
     */
    public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto getParameters(int index) {
      return parameters_.get(index);
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
     */
    public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProtoOrBuilder getParametersOrBuilder(
        int index) {
      return parameters_.get(index);
    }

    // optional bytes content_to_sign = 5;
    public static final int CONTENT_TO_SIGN_FIELD_NUMBER = 5;
    private com.google.protobuf.ByteString contentToSign_;
    /**
     * <code>optional bytes content_to_sign = 5;</code>
     */
    public boolean hasContentToSign() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    /**
     * <code>optional bytes content_to_sign = 5;</code>
     */
    public com.google.protobuf.ByteString getContentToSign() {
      return contentToSign_;
    }

    // optional string resource_path = 6;
    public static final int RESOURCE_PATH_FIELD_NUMBER = 6;
    private Object resourcePath_;
    /**
     * <code>optional string resource_path = 6;</code>
     */
    public boolean hasResourcePath() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    /**
     * <code>optional string resource_path = 6;</code>
     */
    public String getResourcePath() {
      Object ref = resourcePath_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          resourcePath_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string resource_path = 6;</code>
     */
    public com.google.protobuf.ByteString
        getResourcePathBytes() {
      Object ref = resourcePath_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        resourcePath_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional int32 time_offset = 7;
    public static final int TIME_OFFSET_FIELD_NUMBER = 7;
    private int timeOffset_;
    /**
     * <code>optional int32 time_offset = 7;</code>
     *
     * <pre>
     * The following may not be required.
     * </pre>
     */
    public boolean hasTimeOffset() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    /**
     * <code>optional int32 time_offset = 7;</code>
     *
     * <pre>
     * The following may not be required.
     * </pre>
     */
    public int getTimeOffset() {
      return timeOffset_;
    }

    // optional string endpoint_prefix = 8;
    public static final int ENDPOINT_PREFIX_FIELD_NUMBER = 8;
    private Object endpointPrefix_;
    /**
     * <code>optional string endpoint_prefix = 8;</code>
     */
    public boolean hasEndpointPrefix() {
      return ((bitField0_ & 0x00000020) == 0x00000020);
    }
    /**
     * <code>optional string endpoint_prefix = 8;</code>
     */
    public String getEndpointPrefix() {
      Object ref = endpointPrefix_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          endpointPrefix_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string endpoint_prefix = 8;</code>
     */
    public com.google.protobuf.ByteString
        getEndpointPrefixBytes() {
      Object ref = endpointPrefix_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        endpointPrefix_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string service_name = 9;
    public static final int SERVICE_NAME_FIELD_NUMBER = 9;
    private Object serviceName_;
    /**
     * <code>optional string service_name = 9;</code>
     */
    public boolean hasServiceName() {
      return ((bitField0_ & 0x00000040) == 0x00000040);
    }
    /**
     * <code>optional string service_name = 9;</code>
     */
    public String getServiceName() {
      Object ref = serviceName_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          serviceName_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string service_name = 9;</code>
     */
    public com.google.protobuf.ByteString
        getServiceNameBytes() {
      Object ref = serviceName_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        serviceName_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private void initFields() {
      endpoint_ = "";
      httpMethod_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto.DEFAULT;
      headers_ = java.util.Collections.emptyList();
      parameters_ = java.util.Collections.emptyList();
      contentToSign_ = com.google.protobuf.ByteString.EMPTY;
      resourcePath_ = "";
      timeOffset_ = 0;
      endpointPrefix_ = "";
      serviceName_ = "";
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, getEndpointBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeEnum(2, httpMethod_.getNumber());
      }
      for (int i = 0; i < headers_.size(); i++) {
        output.writeMessage(3, headers_.get(i));
      }
      for (int i = 0; i < parameters_.size(); i++) {
        output.writeMessage(4, parameters_.get(i));
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeBytes(5, contentToSign_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeBytes(6, getResourcePathBytes());
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeInt32(7, timeOffset_);
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        output.writeBytes(8, getEndpointPrefixBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        output.writeBytes(9, getServiceNameBytes());
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, getEndpointBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(2, httpMethod_.getNumber());
      }
      for (int i = 0; i < headers_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(3, headers_.get(i));
      }
      for (int i = 0; i < parameters_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(4, parameters_.get(i));
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(5, contentToSign_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(6, getResourcePathBytes());
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(7, timeOffset_);
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(8, getEndpointPrefixBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(9, getServiceNameBytes());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @Override
    protected Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    @Override
    public boolean equals(final Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto)) {
        return super.equals(obj);
      }
      org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto other = (org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto) obj;

      boolean result = true;
      result = result && (hasEndpoint() == other.hasEndpoint());
      if (hasEndpoint()) {
        result = result && getEndpoint()
            .equals(other.getEndpoint());
      }
      result = result && (hasHttpMethod() == other.hasHttpMethod());
      if (hasHttpMethod()) {
        result = result &&
            (getHttpMethod() == other.getHttpMethod());
      }
      result = result && getHeadersList()
          .equals(other.getHeadersList());
      result = result && getParametersList()
          .equals(other.getParametersList());
      result = result && (hasContentToSign() == other.hasContentToSign());
      if (hasContentToSign()) {
        result = result && getContentToSign()
            .equals(other.getContentToSign());
      }
      result = result && (hasResourcePath() == other.hasResourcePath());
      if (hasResourcePath()) {
        result = result && getResourcePath()
            .equals(other.getResourcePath());
      }
      result = result && (hasTimeOffset() == other.hasTimeOffset());
      if (hasTimeOffset()) {
        result = result && (getTimeOffset()
            == other.getTimeOffset());
      }
      result = result && (hasEndpointPrefix() == other.hasEndpointPrefix());
      if (hasEndpointPrefix()) {
        result = result && getEndpointPrefix()
            .equals(other.getEndpointPrefix());
      }
      result = result && (hasServiceName() == other.hasServiceName());
      if (hasServiceName()) {
        result = result && getServiceName()
            .equals(other.getServiceName());
      }
      result = result &&
          getUnknownFields().equals(other.getUnknownFields());
      return result;
    }

    private int memoizedHashCode = 0;
    @Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptorForType().hashCode();
      if (hasEndpoint()) {
        hash = (37 * hash) + ENDPOINT_FIELD_NUMBER;
        hash = (53 * hash) + getEndpoint().hashCode();
      }
      if (hasHttpMethod()) {
        hash = (37 * hash) + HTTP_METHOD_FIELD_NUMBER;
        hash = (53 * hash) + hashEnum(getHttpMethod());
      }
      if (getHeadersCount() > 0) {
        hash = (37 * hash) + HEADERS_FIELD_NUMBER;
        hash = (53 * hash) + getHeadersList().hashCode();
      }
      if (getParametersCount() > 0) {
        hash = (37 * hash) + PARAMETERS_FIELD_NUMBER;
        hash = (53 * hash) + getParametersList().hashCode();
      }
      if (hasContentToSign()) {
        hash = (37 * hash) + CONTENT_TO_SIGN_FIELD_NUMBER;
        hash = (53 * hash) + getContentToSign().hashCode();
      }
      if (hasResourcePath()) {
        hash = (37 * hash) + RESOURCE_PATH_FIELD_NUMBER;
        hash = (53 * hash) + getResourcePath().hashCode();
      }
      if (hasTimeOffset()) {
        hash = (37 * hash) + TIME_OFFSET_FIELD_NUMBER;
        hash = (53 * hash) + getTimeOffset();
      }
      if (hasEndpointPrefix()) {
        hash = (37 * hash) + ENDPOINT_PREFIX_FIELD_NUMBER;
        hash = (53 * hash) + getEndpointPrefix().hashCode();
      }
      if (hasServiceName()) {
        hash = (37 * hash) + SERVICE_NAME_FIELD_NUMBER;
        hash = (53 * hash) + getServiceName().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code org.apache.ranger.raz.s3.lib.signer.SignRequestProto}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProtoOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_SignRequestProto_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_SignRequestProto_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto.class, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto.Builder.class);
      }

      // Construct using org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          getHeadersFieldBuilder();
          getParametersFieldBuilder();
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        endpoint_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        httpMethod_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto.DEFAULT;
        bitField0_ = (bitField0_ & ~0x00000002);
        if (headersBuilder_ == null) {
          headers_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000004);
        } else {
          headersBuilder_.clear();
        }
        if (parametersBuilder_ == null) {
          parameters_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000008);
        } else {
          parametersBuilder_.clear();
        }
        contentToSign_ = com.google.protobuf.ByteString.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000010);
        resourcePath_ = "";
        bitField0_ = (bitField0_ & ~0x00000020);
        timeOffset_ = 0;
        bitField0_ = (bitField0_ & ~0x00000040);
        endpointPrefix_ = "";
        bitField0_ = (bitField0_ & ~0x00000080);
        serviceName_ = "";
        bitField0_ = (bitField0_ & ~0x00000100);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_SignRequestProto_descriptor;
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto getDefaultInstanceForType() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto.getDefaultInstance();
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto build() {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto buildPartial() {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto result = new org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.endpoint_ = endpoint_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.httpMethod_ = httpMethod_;
        if (headersBuilder_ == null) {
          if (((bitField0_ & 0x00000004) == 0x00000004)) {
            headers_ = java.util.Collections.unmodifiableList(headers_);
            bitField0_ = (bitField0_ & ~0x00000004);
          }
          result.headers_ = headers_;
        } else {
          result.headers_ = headersBuilder_.build();
        }
        if (parametersBuilder_ == null) {
          if (((bitField0_ & 0x00000008) == 0x00000008)) {
            parameters_ = java.util.Collections.unmodifiableList(parameters_);
            bitField0_ = (bitField0_ & ~0x00000008);
          }
          result.parameters_ = parameters_;
        } else {
          result.parameters_ = parametersBuilder_.build();
        }
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000004;
        }
        result.contentToSign_ = contentToSign_;
        if (((from_bitField0_ & 0x00000020) == 0x00000020)) {
          to_bitField0_ |= 0x00000008;
        }
        result.resourcePath_ = resourcePath_;
        if (((from_bitField0_ & 0x00000040) == 0x00000040)) {
          to_bitField0_ |= 0x00000010;
        }
        result.timeOffset_ = timeOffset_;
        if (((from_bitField0_ & 0x00000080) == 0x00000080)) {
          to_bitField0_ |= 0x00000020;
        }
        result.endpointPrefix_ = endpointPrefix_;
        if (((from_bitField0_ & 0x00000100) == 0x00000100)) {
          to_bitField0_ |= 0x00000040;
        }
        result.serviceName_ = serviceName_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto) {
          return mergeFrom((org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto other) {
        if (other == org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto.getDefaultInstance()) return this;
        if (other.hasEndpoint()) {
          bitField0_ |= 0x00000001;
          endpoint_ = other.endpoint_;
          onChanged();
        }
        if (other.hasHttpMethod()) {
          setHttpMethod(other.getHttpMethod());
        }
        if (headersBuilder_ == null) {
          if (!other.headers_.isEmpty()) {
            if (headers_.isEmpty()) {
              headers_ = other.headers_;
              bitField0_ = (bitField0_ & ~0x00000004);
            } else {
              ensureHeadersIsMutable();
              headers_.addAll(other.headers_);
            }
            onChanged();
          }
        } else {
          if (!other.headers_.isEmpty()) {
            if (headersBuilder_.isEmpty()) {
              headersBuilder_.dispose();
              headersBuilder_ = null;
              headers_ = other.headers_;
              bitField0_ = (bitField0_ & ~0x00000004);
              headersBuilder_ =
                com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                   getHeadersFieldBuilder() : null;
            } else {
              headersBuilder_.addAllMessages(other.headers_);
            }
          }
        }
        if (parametersBuilder_ == null) {
          if (!other.parameters_.isEmpty()) {
            if (parameters_.isEmpty()) {
              parameters_ = other.parameters_;
              bitField0_ = (bitField0_ & ~0x00000008);
            } else {
              ensureParametersIsMutable();
              parameters_.addAll(other.parameters_);
            }
            onChanged();
          }
        } else {
          if (!other.parameters_.isEmpty()) {
            if (parametersBuilder_.isEmpty()) {
              parametersBuilder_.dispose();
              parametersBuilder_ = null;
              parameters_ = other.parameters_;
              bitField0_ = (bitField0_ & ~0x00000008);
              parametersBuilder_ =
                com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                   getParametersFieldBuilder() : null;
            } else {
              parametersBuilder_.addAllMessages(other.parameters_);
            }
          }
        }
        if (other.hasContentToSign()) {
          setContentToSign(other.getContentToSign());
        }
        if (other.hasResourcePath()) {
          bitField0_ |= 0x00000020;
          resourcePath_ = other.resourcePath_;
          onChanged();
        }
        if (other.hasTimeOffset()) {
          setTimeOffset(other.getTimeOffset());
        }
        if (other.hasEndpointPrefix()) {
          bitField0_ |= 0x00000080;
          endpointPrefix_ = other.endpointPrefix_;
          onChanged();
        }
        if (other.hasServiceName()) {
          bitField0_ |= 0x00000100;
          serviceName_ = other.serviceName_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignRequestProto) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional string endpoint = 1;
      private Object endpoint_ = "";
      /**
       * <code>optional string endpoint = 1;</code>
       */
      public boolean hasEndpoint() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional string endpoint = 1;</code>
       */
      public String getEndpoint() {
        Object ref = endpoint_;
        if (!(ref instanceof String)) {
          String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          endpoint_ = s;
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>optional string endpoint = 1;</code>
       */
      public com.google.protobuf.ByteString
          getEndpointBytes() {
        Object ref = endpoint_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          endpoint_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string endpoint = 1;</code>
       */
      public Builder setEndpoint(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        endpoint_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string endpoint = 1;</code>
       */
      public Builder clearEndpoint() {
        bitField0_ = (bitField0_ & ~0x00000001);
        endpoint_ = getDefaultInstance().getEndpoint();
        onChanged();
        return this;
      }
      /**
       * <code>optional string endpoint = 1;</code>
       */
      public Builder setEndpointBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        endpoint_ = value;
        onChanged();
        return this;
      }

      // optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;
      private org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto httpMethod_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto.DEFAULT;
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;</code>
       */
      public boolean hasHttpMethod() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto getHttpMethod() {
        return httpMethod_;
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;</code>
       */
      public Builder setHttpMethod(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto value) {
        if (value == null) {
          throw new NullPointerException();
        }
        bitField0_ |= 0x00000002;
        httpMethod_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.HttpMethodProto http_method = 2;</code>
       */
      public Builder clearHttpMethod() {
        bitField0_ = (bitField0_ & ~0x00000002);
        httpMethod_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.HttpMethodProto.DEFAULT;
        onChanged();
        return this;
      }

      // repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;
      private java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto> headers_ =
        java.util.Collections.emptyList();
      private void ensureHeadersIsMutable() {
        if (!((bitField0_ & 0x00000004) == 0x00000004)) {
          headers_ = new java.util.ArrayList<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto>(headers_);
          bitField0_ |= 0x00000004;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilder<
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder> headersBuilder_;

      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto> getHeadersList() {
        if (headersBuilder_ == null) {
          return java.util.Collections.unmodifiableList(headers_);
        } else {
          return headersBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public int getHeadersCount() {
        if (headersBuilder_ == null) {
          return headers_.size();
        } else {
          return headersBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto getHeaders(int index) {
        if (headersBuilder_ == null) {
          return headers_.get(index);
        } else {
          return headersBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public Builder setHeaders(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto value) {
        if (headersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureHeadersIsMutable();
          headers_.set(index, value);
          onChanged();
        } else {
          headersBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public Builder setHeaders(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder builderForValue) {
        if (headersBuilder_ == null) {
          ensureHeadersIsMutable();
          headers_.set(index, builderForValue.build());
          onChanged();
        } else {
          headersBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public Builder addHeaders(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto value) {
        if (headersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureHeadersIsMutable();
          headers_.add(value);
          onChanged();
        } else {
          headersBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public Builder addHeaders(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto value) {
        if (headersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureHeadersIsMutable();
          headers_.add(index, value);
          onChanged();
        } else {
          headersBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public Builder addHeaders(
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder builderForValue) {
        if (headersBuilder_ == null) {
          ensureHeadersIsMutable();
          headers_.add(builderForValue.build());
          onChanged();
        } else {
          headersBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public Builder addHeaders(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder builderForValue) {
        if (headersBuilder_ == null) {
          ensureHeadersIsMutable();
          headers_.add(index, builderForValue.build());
          onChanged();
        } else {
          headersBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public Builder addAllHeaders(
          Iterable<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto> values) {
        if (headersBuilder_ == null) {
          ensureHeadersIsMutable();
          super.addAll(values, headers_);
          onChanged();
        } else {
          headersBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public Builder clearHeaders() {
        if (headersBuilder_ == null) {
          headers_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000004);
          onChanged();
        } else {
          headersBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public Builder removeHeaders(int index) {
        if (headersBuilder_ == null) {
          ensureHeadersIsMutable();
          headers_.remove(index);
          onChanged();
        } else {
          headersBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder getHeadersBuilder(
          int index) {
        return getHeadersFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder getHeadersOrBuilder(
          int index) {
        if (headersBuilder_ == null) {
          return headers_.get(index);  } else {
          return headersBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public java.util.List<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder>
           getHeadersOrBuilderList() {
        if (headersBuilder_ != null) {
          return headersBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(headers_);
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder addHeadersBuilder() {
        return getHeadersFieldBuilder().addBuilder(
            org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.getDefaultInstance());
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder addHeadersBuilder(
          int index) {
        return getHeadersFieldBuilder().addBuilder(
            index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.getDefaultInstance());
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto headers = 3;</code>
       */
      public java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder>
           getHeadersBuilderList() {
        return getHeadersFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilder<
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder>
          getHeadersFieldBuilder() {
        if (headersBuilder_ == null) {
          headersBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder>(
                  headers_,
                  ((bitField0_ & 0x00000004) == 0x00000004),
                  getParentForChildren(),
                  isClean());
          headers_ = null;
        }
        return headersBuilder_;
      }

      // repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;
      private java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto> parameters_ =
        java.util.Collections.emptyList();
      private void ensureParametersIsMutable() {
        if (!((bitField0_ & 0x00000008) == 0x00000008)) {
          parameters_ = new java.util.ArrayList<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto>(parameters_);
          bitField0_ |= 0x00000008;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilder<
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProtoOrBuilder> parametersBuilder_;

      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto> getParametersList() {
        if (parametersBuilder_ == null) {
          return java.util.Collections.unmodifiableList(parameters_);
        } else {
          return parametersBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public int getParametersCount() {
        if (parametersBuilder_ == null) {
          return parameters_.size();
        } else {
          return parametersBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto getParameters(int index) {
        if (parametersBuilder_ == null) {
          return parameters_.get(index);
        } else {
          return parametersBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public Builder setParameters(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto value) {
        if (parametersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureParametersIsMutable();
          parameters_.set(index, value);
          onChanged();
        } else {
          parametersBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public Builder setParameters(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder builderForValue) {
        if (parametersBuilder_ == null) {
          ensureParametersIsMutable();
          parameters_.set(index, builderForValue.build());
          onChanged();
        } else {
          parametersBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public Builder addParameters(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto value) {
        if (parametersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureParametersIsMutable();
          parameters_.add(value);
          onChanged();
        } else {
          parametersBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public Builder addParameters(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto value) {
        if (parametersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureParametersIsMutable();
          parameters_.add(index, value);
          onChanged();
        } else {
          parametersBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public Builder addParameters(
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder builderForValue) {
        if (parametersBuilder_ == null) {
          ensureParametersIsMutable();
          parameters_.add(builderForValue.build());
          onChanged();
        } else {
          parametersBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public Builder addParameters(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder builderForValue) {
        if (parametersBuilder_ == null) {
          ensureParametersIsMutable();
          parameters_.add(index, builderForValue.build());
          onChanged();
        } else {
          parametersBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public Builder addAllParameters(
          Iterable<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto> values) {
        if (parametersBuilder_ == null) {
          ensureParametersIsMutable();
          super.addAll(values, parameters_);
          onChanged();
        } else {
          parametersBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public Builder clearParameters() {
        if (parametersBuilder_ == null) {
          parameters_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000008);
          onChanged();
        } else {
          parametersBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public Builder removeParameters(int index) {
        if (parametersBuilder_ == null) {
          ensureParametersIsMutable();
          parameters_.remove(index);
          onChanged();
        } else {
          parametersBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder getParametersBuilder(
          int index) {
        return getParametersFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProtoOrBuilder getParametersOrBuilder(
          int index) {
        if (parametersBuilder_ == null) {
          return parameters_.get(index);  } else {
          return parametersBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public java.util.List<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProtoOrBuilder>
           getParametersOrBuilderList() {
        if (parametersBuilder_ != null) {
          return parametersBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(parameters_);
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder addParametersBuilder() {
        return getParametersFieldBuilder().addBuilder(
            org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.getDefaultInstance());
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder addParametersBuilder(
          int index) {
        return getParametersFieldBuilder().addBuilder(
            index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.getDefaultInstance());
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringListStringMapProto parameters = 4;</code>
       */
      public java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder>
           getParametersBuilderList() {
        return getParametersFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilder<
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProtoOrBuilder>
          getParametersFieldBuilder() {
        if (parametersBuilder_ == null) {
          parametersBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringListStringMapProtoOrBuilder>(
                  parameters_,
                  ((bitField0_ & 0x00000008) == 0x00000008),
                  getParentForChildren(),
                  isClean());
          parameters_ = null;
        }
        return parametersBuilder_;
      }

      // optional bytes content_to_sign = 5;
      private com.google.protobuf.ByteString contentToSign_ = com.google.protobuf.ByteString.EMPTY;
      /**
       * <code>optional bytes content_to_sign = 5;</code>
       */
      public boolean hasContentToSign() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      /**
       * <code>optional bytes content_to_sign = 5;</code>
       */
      public com.google.protobuf.ByteString getContentToSign() {
        return contentToSign_;
      }
      /**
       * <code>optional bytes content_to_sign = 5;</code>
       */
      public Builder setContentToSign(com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000010;
        contentToSign_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional bytes content_to_sign = 5;</code>
       */
      public Builder clearContentToSign() {
        bitField0_ = (bitField0_ & ~0x00000010);
        contentToSign_ = getDefaultInstance().getContentToSign();
        onChanged();
        return this;
      }

      // optional string resource_path = 6;
      private Object resourcePath_ = "";
      /**
       * <code>optional string resource_path = 6;</code>
       */
      public boolean hasResourcePath() {
        return ((bitField0_ & 0x00000020) == 0x00000020);
      }
      /**
       * <code>optional string resource_path = 6;</code>
       */
      public String getResourcePath() {
        Object ref = resourcePath_;
        if (!(ref instanceof String)) {
          String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          resourcePath_ = s;
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>optional string resource_path = 6;</code>
       */
      public com.google.protobuf.ByteString
          getResourcePathBytes() {
        Object ref = resourcePath_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          resourcePath_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string resource_path = 6;</code>
       */
      public Builder setResourcePath(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        resourcePath_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string resource_path = 6;</code>
       */
      public Builder clearResourcePath() {
        bitField0_ = (bitField0_ & ~0x00000020);
        resourcePath_ = getDefaultInstance().getResourcePath();
        onChanged();
        return this;
      }
      /**
       * <code>optional string resource_path = 6;</code>
       */
      public Builder setResourcePathBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        resourcePath_ = value;
        onChanged();
        return this;
      }

      // optional int32 time_offset = 7;
      private int timeOffset_ ;
      /**
       * <code>optional int32 time_offset = 7;</code>
       *
       * <pre>
       * The following may not be required.
       * </pre>
       */
      public boolean hasTimeOffset() {
        return ((bitField0_ & 0x00000040) == 0x00000040);
      }
      /**
       * <code>optional int32 time_offset = 7;</code>
       *
       * <pre>
       * The following may not be required.
       * </pre>
       */
      public int getTimeOffset() {
        return timeOffset_;
      }
      /**
       * <code>optional int32 time_offset = 7;</code>
       *
       * <pre>
       * The following may not be required.
       * </pre>
       */
      public Builder setTimeOffset(int value) {
        bitField0_ |= 0x00000040;
        timeOffset_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int32 time_offset = 7;</code>
       *
       * <pre>
       * The following may not be required.
       * </pre>
       */
      public Builder clearTimeOffset() {
        bitField0_ = (bitField0_ & ~0x00000040);
        timeOffset_ = 0;
        onChanged();
        return this;
      }

      // optional string endpoint_prefix = 8;
      private Object endpointPrefix_ = "";
      /**
       * <code>optional string endpoint_prefix = 8;</code>
       */
      public boolean hasEndpointPrefix() {
        return ((bitField0_ & 0x00000080) == 0x00000080);
      }
      /**
       * <code>optional string endpoint_prefix = 8;</code>
       */
      public String getEndpointPrefix() {
        Object ref = endpointPrefix_;
        if (!(ref instanceof String)) {
          String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          endpointPrefix_ = s;
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>optional string endpoint_prefix = 8;</code>
       */
      public com.google.protobuf.ByteString
          getEndpointPrefixBytes() {
        Object ref = endpointPrefix_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          endpointPrefix_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string endpoint_prefix = 8;</code>
       */
      public Builder setEndpointPrefix(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000080;
        endpointPrefix_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string endpoint_prefix = 8;</code>
       */
      public Builder clearEndpointPrefix() {
        bitField0_ = (bitField0_ & ~0x00000080);
        endpointPrefix_ = getDefaultInstance().getEndpointPrefix();
        onChanged();
        return this;
      }
      /**
       * <code>optional string endpoint_prefix = 8;</code>
       */
      public Builder setEndpointPrefixBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000080;
        endpointPrefix_ = value;
        onChanged();
        return this;
      }

      // optional string service_name = 9;
      private Object serviceName_ = "";
      /**
       * <code>optional string service_name = 9;</code>
       */
      public boolean hasServiceName() {
        return ((bitField0_ & 0x00000100) == 0x00000100);
      }
      /**
       * <code>optional string service_name = 9;</code>
       */
      public String getServiceName() {
        Object ref = serviceName_;
        if (!(ref instanceof String)) {
          String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          serviceName_ = s;
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>optional string service_name = 9;</code>
       */
      public com.google.protobuf.ByteString
          getServiceNameBytes() {
        Object ref = serviceName_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          serviceName_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string service_name = 9;</code>
       */
      public Builder setServiceName(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        serviceName_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string service_name = 9;</code>
       */
      public Builder clearServiceName() {
        bitField0_ = (bitField0_ & ~0x00000100);
        serviceName_ = getDefaultInstance().getServiceName();
        onChanged();
        return this;
      }
      /**
       * <code>optional string service_name = 9;</code>
       */
      public Builder setServiceNameBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        serviceName_ = value;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:org.apache.ranger.raz.s3.lib.signer.SignRequestProto)
    }

    static {
      defaultInstance = new SignRequestProto(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:org.apache.ranger.raz.s3.lib.signer.SignRequestProto)
  }

  public interface SignResponseProtoOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
     */
    boolean hasAuthorizationResponse();
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
     */
    org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto getAuthorizationResponse();
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
     */
    org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProtoOrBuilder getAuthorizationResponseOrBuilder();

    // repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
     *
     * <pre>
     * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
     * </pre>
     */
    java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto>
        getSignerGeneratedHeadersList();
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
     *
     * <pre>
     * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
     * </pre>
     */
    org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto getSignerGeneratedHeaders(int index);
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
     *
     * <pre>
     * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
     * </pre>
     */
    int getSignerGeneratedHeadersCount();
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
     *
     * <pre>
     * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
     * </pre>
     */
    java.util.List<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder>
        getSignerGeneratedHeadersOrBuilderList();
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
     *
     * <pre>
     * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
     * </pre>
     */
    org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder getSignerGeneratedHeadersOrBuilder(
        int index);

    // optional string region = 3;
    /**
     * <code>optional string region = 3;</code>
     */
    boolean hasRegion();
    /**
     * <code>optional string region = 3;</code>
     */
    String getRegion();
    /**
     * <code>optional string region = 3;</code>
     */
    com.google.protobuf.ByteString
        getRegionBytes();
  }
  /**
   * Protobuf type {@code org.apache.ranger.raz.s3.lib.signer.SignResponseProto}
   */
  public static final class SignResponseProto extends
      com.google.protobuf.GeneratedMessage
      implements SignResponseProtoOrBuilder {
    // Use SignResponseProto.newBuilder() to construct.
    private SignResponseProto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private SignResponseProto(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final SignResponseProto defaultInstance;
    public static SignResponseProto getDefaultInstance() {
      return defaultInstance;
    }

    public SignResponseProto getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private SignResponseProto(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) == 0x00000001)) {
                subBuilder = authorizationResponse_.toBuilder();
              }
              authorizationResponse_ = input.readMessage(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(authorizationResponse_);
                authorizationResponse_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 18: {
              if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
                signerGeneratedHeaders_ = new java.util.ArrayList<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto>();
                mutable_bitField0_ |= 0x00000002;
              }
              signerGeneratedHeaders_.add(input.readMessage(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.PARSER, extensionRegistry));
              break;
            }
            case 26: {
              bitField0_ |= 0x00000002;
              region_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
          signerGeneratedHeaders_ = java.util.Collections.unmodifiableList(signerGeneratedHeaders_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_SignResponseProto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_SignResponseProto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto.class, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto.Builder.class);
    }

    public static com.google.protobuf.Parser<SignResponseProto> PARSER =
        new com.google.protobuf.AbstractParser<SignResponseProto>() {
      public SignResponseProto parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new SignResponseProto(input, extensionRegistry);
      }
    };

    @Override
    public com.google.protobuf.Parser<SignResponseProto> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;
    public static final int AUTHORIZATION_RESPONSE_FIELD_NUMBER = 1;
    private org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto authorizationResponse_;
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
     */
    public boolean hasAuthorizationResponse() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
     */
    public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto getAuthorizationResponse() {
      return authorizationResponse_;
    }
    /**
     * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
     */
    public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProtoOrBuilder getAuthorizationResponseOrBuilder() {
      return authorizationResponse_;
    }

    // repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;
    public static final int SIGNER_GENERATED_HEADERS_FIELD_NUMBER = 2;
    private java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto> signerGeneratedHeaders_;
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
     *
     * <pre>
     * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
     * </pre>
     */
    public java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto> getSignerGeneratedHeadersList() {
      return signerGeneratedHeaders_;
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
     *
     * <pre>
     * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
     * </pre>
     */
    public java.util.List<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder>
        getSignerGeneratedHeadersOrBuilderList() {
      return signerGeneratedHeaders_;
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
     *
     * <pre>
     * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
     * </pre>
     */
    public int getSignerGeneratedHeadersCount() {
      return signerGeneratedHeaders_.size();
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
     *
     * <pre>
     * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
     * </pre>
     */
    public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto getSignerGeneratedHeaders(int index) {
      return signerGeneratedHeaders_.get(index);
    }
    /**
     * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
     *
     * <pre>
     * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
     * </pre>
     */
    public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder getSignerGeneratedHeadersOrBuilder(
        int index) {
      return signerGeneratedHeaders_.get(index);
    }

    // optional string region = 3;
    public static final int REGION_FIELD_NUMBER = 3;
    private Object region_;
    /**
     * <code>optional string region = 3;</code>
     */
    public boolean hasRegion() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional string region = 3;</code>
     */
    public String getRegion() {
      Object ref = region_;
      if (ref instanceof String) {
        return (String) ref;
      } else {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          region_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string region = 3;</code>
     */
    public com.google.protobuf.ByteString
        getRegionBytes() {
      Object ref = region_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8(
                (String) ref);
        region_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private void initFields() {
      authorizationResponse_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.getDefaultInstance();
      signerGeneratedHeaders_ = java.util.Collections.emptyList();
      region_ = "";
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeMessage(1, authorizationResponse_);
      }
      for (int i = 0; i < signerGeneratedHeaders_.size(); i++) {
        output.writeMessage(2, signerGeneratedHeaders_.get(i));
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(3, getRegionBytes());
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(1, authorizationResponse_);
      }
      for (int i = 0; i < signerGeneratedHeaders_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(2, signerGeneratedHeaders_.get(i));
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(3, getRegionBytes());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @Override
    protected Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    @Override
    public boolean equals(final Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto)) {
        return super.equals(obj);
      }
      org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto other = (org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto) obj;

      boolean result = true;
      result = result && (hasAuthorizationResponse() == other.hasAuthorizationResponse());
      if (hasAuthorizationResponse()) {
        result = result && getAuthorizationResponse()
            .equals(other.getAuthorizationResponse());
      }
      result = result && getSignerGeneratedHeadersList()
          .equals(other.getSignerGeneratedHeadersList());
      result = result && (hasRegion() == other.hasRegion());
      if (hasRegion()) {
        result = result && getRegion()
            .equals(other.getRegion());
      }
      result = result &&
          getUnknownFields().equals(other.getUnknownFields());
      return result;
    }

    private int memoizedHashCode = 0;
    @Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptorForType().hashCode();
      if (hasAuthorizationResponse()) {
        hash = (37 * hash) + AUTHORIZATION_RESPONSE_FIELD_NUMBER;
        hash = (53 * hash) + getAuthorizationResponse().hashCode();
      }
      if (getSignerGeneratedHeadersCount() > 0) {
        hash = (37 * hash) + SIGNER_GENERATED_HEADERS_FIELD_NUMBER;
        hash = (53 * hash) + getSignerGeneratedHeadersList().hashCode();
      }
      if (hasRegion()) {
        hash = (37 * hash) + REGION_FIELD_NUMBER;
        hash = (53 * hash) + getRegion().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code org.apache.ranger.raz.s3.lib.signer.SignResponseProto}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProtoOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_SignResponseProto_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_SignResponseProto_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto.class, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto.Builder.class);
      }

      // Construct using org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          getAuthorizationResponseFieldBuilder();
          getSignerGeneratedHeadersFieldBuilder();
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        if (authorizationResponseBuilder_ == null) {
          authorizationResponse_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.getDefaultInstance();
        } else {
          authorizationResponseBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        if (signerGeneratedHeadersBuilder_ == null) {
          signerGeneratedHeaders_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000002);
        } else {
          signerGeneratedHeadersBuilder_.clear();
        }
        region_ = "";
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.internal_static_com_cloudera_cloud_storage_signer_SignResponseProto_descriptor;
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto getDefaultInstanceForType() {
        return org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto.getDefaultInstance();
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto build() {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto buildPartial() {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto result = new org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        if (authorizationResponseBuilder_ == null) {
          result.authorizationResponse_ = authorizationResponse_;
        } else {
          result.authorizationResponse_ = authorizationResponseBuilder_.build();
        }
        if (signerGeneratedHeadersBuilder_ == null) {
          if (((bitField0_ & 0x00000002) == 0x00000002)) {
            signerGeneratedHeaders_ = java.util.Collections.unmodifiableList(signerGeneratedHeaders_);
            bitField0_ = (bitField0_ & ~0x00000002);
          }
          result.signerGeneratedHeaders_ = signerGeneratedHeaders_;
        } else {
          result.signerGeneratedHeaders_ = signerGeneratedHeadersBuilder_.build();
        }
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000002;
        }
        result.region_ = region_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto) {
          return mergeFrom((org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto other) {
        if (other == org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto.getDefaultInstance()) return this;
        if (other.hasAuthorizationResponse()) {
          mergeAuthorizationResponse(other.getAuthorizationResponse());
        }
        if (signerGeneratedHeadersBuilder_ == null) {
          if (!other.signerGeneratedHeaders_.isEmpty()) {
            if (signerGeneratedHeaders_.isEmpty()) {
              signerGeneratedHeaders_ = other.signerGeneratedHeaders_;
              bitField0_ = (bitField0_ & ~0x00000002);
            } else {
              ensureSignerGeneratedHeadersIsMutable();
              signerGeneratedHeaders_.addAll(other.signerGeneratedHeaders_);
            }
            onChanged();
          }
        } else {
          if (!other.signerGeneratedHeaders_.isEmpty()) {
            if (signerGeneratedHeadersBuilder_.isEmpty()) {
              signerGeneratedHeadersBuilder_.dispose();
              signerGeneratedHeadersBuilder_ = null;
              signerGeneratedHeaders_ = other.signerGeneratedHeaders_;
              bitField0_ = (bitField0_ & ~0x00000002);
              signerGeneratedHeadersBuilder_ =
                com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                   getSignerGeneratedHeadersFieldBuilder() : null;
            } else {
              signerGeneratedHeadersBuilder_.addAllMessages(other.signerGeneratedHeaders_);
            }
          }
        }
        if (other.hasRegion()) {
          bitField0_ |= 0x00000004;
          region_ = other.region_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.SignResponseProto) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;
      private org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto authorizationResponse_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.getDefaultInstance();
      private com.google.protobuf.SingleFieldBuilder<
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProtoOrBuilder> authorizationResponseBuilder_;
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
       */
      public boolean hasAuthorizationResponse() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto getAuthorizationResponse() {
        if (authorizationResponseBuilder_ == null) {
          return authorizationResponse_;
        } else {
          return authorizationResponseBuilder_.getMessage();
        }
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
       */
      public Builder setAuthorizationResponse(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto value) {
        if (authorizationResponseBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          authorizationResponse_ = value;
          onChanged();
        } else {
          authorizationResponseBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
       */
      public Builder setAuthorizationResponse(
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.Builder builderForValue) {
        if (authorizationResponseBuilder_ == null) {
          authorizationResponse_ = builderForValue.build();
          onChanged();
        } else {
          authorizationResponseBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
       */
      public Builder mergeAuthorizationResponse(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto value) {
        if (authorizationResponseBuilder_ == null) {
          if (((bitField0_ & 0x00000001) == 0x00000001) &&
              authorizationResponse_ != org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.getDefaultInstance()) {
            authorizationResponse_ =
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.newBuilder(authorizationResponse_).mergeFrom(value).buildPartial();
          } else {
            authorizationResponse_ = value;
          }
          onChanged();
        } else {
          authorizationResponseBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
       */
      public Builder clearAuthorizationResponse() {
        if (authorizationResponseBuilder_ == null) {
          authorizationResponse_ = org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.getDefaultInstance();
          onChanged();
        } else {
          authorizationResponseBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.Builder getAuthorizationResponseBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getAuthorizationResponseFieldBuilder().getBuilder();
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProtoOrBuilder getAuthorizationResponseOrBuilder() {
        if (authorizationResponseBuilder_ != null) {
          return authorizationResponseBuilder_.getMessageOrBuilder();
        } else {
          return authorizationResponse_;
        }
      }
      /**
       * <code>optional .org.apache.ranger.raz.s3.lib.signer.AuthorizationResponseProto authorization_response = 1;</code>
       */
      private com.google.protobuf.SingleFieldBuilder<
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProtoOrBuilder>
          getAuthorizationResponseFieldBuilder() {
        if (authorizationResponseBuilder_ == null) {
          authorizationResponseBuilder_ = new com.google.protobuf.SingleFieldBuilder<
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.AuthorizationResponseProtoOrBuilder>(
                  authorizationResponse_,
                  getParentForChildren(),
                  isClean());
          authorizationResponse_ = null;
        }
        return authorizationResponseBuilder_;
      }

      // repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;
      private java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto> signerGeneratedHeaders_ =
        java.util.Collections.emptyList();
      private void ensureSignerGeneratedHeadersIsMutable() {
        if (!((bitField0_ & 0x00000002) == 0x00000002)) {
          signerGeneratedHeaders_ = new java.util.ArrayList<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto>(signerGeneratedHeaders_);
          bitField0_ |= 0x00000002;
         }
      }

      private com.google.protobuf.RepeatedFieldBuilder<
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder> signerGeneratedHeadersBuilder_;

      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto> getSignerGeneratedHeadersList() {
        if (signerGeneratedHeadersBuilder_ == null) {
          return java.util.Collections.unmodifiableList(signerGeneratedHeaders_);
        } else {
          return signerGeneratedHeadersBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public int getSignerGeneratedHeadersCount() {
        if (signerGeneratedHeadersBuilder_ == null) {
          return signerGeneratedHeaders_.size();
        } else {
          return signerGeneratedHeadersBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto getSignerGeneratedHeaders(int index) {
        if (signerGeneratedHeadersBuilder_ == null) {
          return signerGeneratedHeaders_.get(index);
        } else {
          return signerGeneratedHeadersBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public Builder setSignerGeneratedHeaders(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto value) {
        if (signerGeneratedHeadersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSignerGeneratedHeadersIsMutable();
          signerGeneratedHeaders_.set(index, value);
          onChanged();
        } else {
          signerGeneratedHeadersBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public Builder setSignerGeneratedHeaders(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder builderForValue) {
        if (signerGeneratedHeadersBuilder_ == null) {
          ensureSignerGeneratedHeadersIsMutable();
          signerGeneratedHeaders_.set(index, builderForValue.build());
          onChanged();
        } else {
          signerGeneratedHeadersBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public Builder addSignerGeneratedHeaders(org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto value) {
        if (signerGeneratedHeadersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSignerGeneratedHeadersIsMutable();
          signerGeneratedHeaders_.add(value);
          onChanged();
        } else {
          signerGeneratedHeadersBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public Builder addSignerGeneratedHeaders(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto value) {
        if (signerGeneratedHeadersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSignerGeneratedHeadersIsMutable();
          signerGeneratedHeaders_.add(index, value);
          onChanged();
        } else {
          signerGeneratedHeadersBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public Builder addSignerGeneratedHeaders(
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder builderForValue) {
        if (signerGeneratedHeadersBuilder_ == null) {
          ensureSignerGeneratedHeadersIsMutable();
          signerGeneratedHeaders_.add(builderForValue.build());
          onChanged();
        } else {
          signerGeneratedHeadersBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public Builder addSignerGeneratedHeaders(
          int index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder builderForValue) {
        if (signerGeneratedHeadersBuilder_ == null) {
          ensureSignerGeneratedHeadersIsMutable();
          signerGeneratedHeaders_.add(index, builderForValue.build());
          onChanged();
        } else {
          signerGeneratedHeadersBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public Builder addAllSignerGeneratedHeaders(
          Iterable<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto> values) {
        if (signerGeneratedHeadersBuilder_ == null) {
          ensureSignerGeneratedHeadersIsMutable();
          super.addAll(values, signerGeneratedHeaders_);
          onChanged();
        } else {
          signerGeneratedHeadersBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public Builder clearSignerGeneratedHeaders() {
        if (signerGeneratedHeadersBuilder_ == null) {
          signerGeneratedHeaders_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000002);
          onChanged();
        } else {
          signerGeneratedHeadersBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public Builder removeSignerGeneratedHeaders(int index) {
        if (signerGeneratedHeadersBuilder_ == null) {
          ensureSignerGeneratedHeadersIsMutable();
          signerGeneratedHeaders_.remove(index);
          onChanged();
        } else {
          signerGeneratedHeadersBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder getSignerGeneratedHeadersBuilder(
          int index) {
        return getSignerGeneratedHeadersFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder getSignerGeneratedHeadersOrBuilder(
          int index) {
        if (signerGeneratedHeadersBuilder_ == null) {
          return signerGeneratedHeaders_.get(index);  } else {
          return signerGeneratedHeadersBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public java.util.List<? extends org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder>
           getSignerGeneratedHeadersOrBuilderList() {
        if (signerGeneratedHeadersBuilder_ != null) {
          return signerGeneratedHeadersBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(signerGeneratedHeaders_);
        }
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder addSignerGeneratedHeadersBuilder() {
        return getSignerGeneratedHeadersFieldBuilder().addBuilder(
            org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.getDefaultInstance());
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder addSignerGeneratedHeadersBuilder(
          int index) {
        return getSignerGeneratedHeadersFieldBuilder().addBuilder(
            index, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.getDefaultInstance());
      }
      /**
       * <code>repeated .org.apache.ranger.raz.s3.lib.signer.StringStringMapProto signer_generated_headers = 2;</code>
       *
       * <pre>
       * TODO: Move this to a union. GCS, for example, will return a signed url and not headers
       * </pre>
       */
      public java.util.List<org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder>
           getSignerGeneratedHeadersBuilderList() {
        return getSignerGeneratedHeadersFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilder<
          org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder>
          getSignerGeneratedHeadersFieldBuilder() {
        if (signerGeneratedHeadersBuilder_ == null) {
          signerGeneratedHeadersBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
              org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProto.Builder, org.apache.ranger.raz.s3.lib.signer.protos.SignerProtocolProtos.StringStringMapProtoOrBuilder>(
                  signerGeneratedHeaders_,
                  ((bitField0_ & 0x00000002) == 0x00000002),
                  getParentForChildren(),
                  isClean());
          signerGeneratedHeaders_ = null;
        }
        return signerGeneratedHeadersBuilder_;
      }

      // optional string region = 3;
      private Object region_ = "";
      /**
       * <code>optional string region = 3;</code>
       */
      public boolean hasRegion() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>optional string region = 3;</code>
       */
      public String getRegion() {
        Object ref = region_;
        if (!(ref instanceof String)) {
          String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          region_ = s;
          return s;
        } else {
          return (String) ref;
        }
      }
      /**
       * <code>optional string region = 3;</code>
       */
      public com.google.protobuf.ByteString
          getRegionBytes() {
        Object ref = region_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8(
                  (String) ref);
          region_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string region = 3;</code>
       */
      public Builder setRegion(
          String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        region_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string region = 3;</code>
       */
      public Builder clearRegion() {
        bitField0_ = (bitField0_ & ~0x00000004);
        region_ = getDefaultInstance().getRegion();
        onChanged();
        return this;
      }
      /**
       * <code>optional string region = 3;</code>
       */
      public Builder setRegionBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        region_ = value;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:org.apache.ranger.raz.s3.lib.signer.SignResponseProto)
    }

    static {
      defaultInstance = new SignResponseProto(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:org.apache.ranger.raz.s3.lib.signer.SignResponseProto)
  }

  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_com_cloudera_cloud_storage_signer_StringStringMapProto_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_com_cloudera_cloud_storage_signer_StringStringMapProto_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_com_cloudera_cloud_storage_signer_StringListStringMapProto_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_com_cloudera_cloud_storage_signer_StringListStringMapProto_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_com_cloudera_cloud_storage_signer_AuthorizationResponseProto_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_com_cloudera_cloud_storage_signer_AuthorizationResponseProto_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_com_cloudera_cloud_storage_signer_SignRequestProto_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_com_cloudera_cloud_storage_signer_SignRequestProto_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_com_cloudera_cloud_storage_signer_SignResponseProto_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_com_cloudera_cloud_storage_signer_SignResponseProto_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    String[] descriptorData = {
      "\n\023signer_protos.proto\022!com.cloudera.clou" +
      "d.storage.signer\"2\n\024StringStringMapProto" +
      "\022\013\n\003key\030\001 \001(\t\022\r\n\005value\030\002 \001(\t\"6\n\030StringLi" +
      "stStringMapProto\022\013\n\003key\030\001 \001(\t\022\r\n\005value\030\002" +
      " \003(\t\"\237\001\n\032AuthorizationResponseProto\022K\n\rr" +
      "esponse_code\030\001 \001(\01624.com.cloudera.cloud." +
      "storage.signer.ResponseCodeProto\022\032\n\022unau" +
      "thorized_paths\030\002 \003(\t\022\030\n\020response_message" +
      "\030\003 \001(\t\"\374\002\n\020SignRequestProto\022\020\n\010endpoint\030" +
      "\001 \001(\t\022G\n\013http_method\030\002 \001(\01622.com.clouder",
      "a.cloud.storage.signer.HttpMethodProto\022H" +
      "\n\007headers\030\003 \003(\01327.com.cloudera.cloud.sto" +
      "rage.signer.StringStringMapProto\022O\n\npara" +
      "meters\030\004 \003(\0132;.com.cloudera.cloud.storag" +
      "e.signer.StringListStringMapProto\022\027\n\017con" +
      "tent_to_sign\030\005 \001(\014\022\025\n\rresource_path\030\006 \001(" +
      "\t\022\023\n\013time_offset\030\007 \001(\005\022\027\n\017endpoint_prefi" +
      "x\030\010 \001(\t\022\024\n\014service_name\030\t \001(\t\"\335\001\n\021SignRe" +
      "sponseProto\022]\n\026authorization_response\030\001 " +
      "\001(\0132=.org.apache.ranger.raz.s3.lib.signer.",
      "AuthorizationResponseProto\022Y\n\030signer_gen" +
      "erated_headers\030\002 \003(\01327.com.cloudera.clou" +
      "d.storage.signer.StringStringMapProto\022\016\n" +
      "\006region\030\003 \001(\t*P\n\017HttpMethodProto\022\013\n\007DEFA" +
      "ULT\020\000\022\007\n\003GET\020\001\022\010\n\004POST\020\002\022\007\n\003PUT\020\003\022\n\n\006DEL" +
      "ETE\020\004\022\010\n\004HEAD\020\005*_\n\021ResponseCodeProto\022\024\n\020" +
      "AUTHZ_AUTHORIZED\020\000\022\026\n\022AUTHZ_UNAUTHORIZED" +
      "\020\001\022\021\n\rAUTHZ_UNKNOWN\020\002\022\t\n\005ERROR\020\003BF\n(com." +
      "cloudera.cloud.storage.signer.protosB\024Si" +
      "gnerProtocolProtos\210\001\001\240\001\001"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_com_cloudera_cloud_storage_signer_StringStringMapProto_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_com_cloudera_cloud_storage_signer_StringStringMapProto_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_com_cloudera_cloud_storage_signer_StringStringMapProto_descriptor,
              new String[] { "Key", "Value", });
          internal_static_com_cloudera_cloud_storage_signer_StringListStringMapProto_descriptor =
            getDescriptor().getMessageTypes().get(1);
          internal_static_com_cloudera_cloud_storage_signer_StringListStringMapProto_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_com_cloudera_cloud_storage_signer_StringListStringMapProto_descriptor,
              new String[] { "Key", "Value", });
          internal_static_com_cloudera_cloud_storage_signer_AuthorizationResponseProto_descriptor =
            getDescriptor().getMessageTypes().get(2);
          internal_static_com_cloudera_cloud_storage_signer_AuthorizationResponseProto_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_com_cloudera_cloud_storage_signer_AuthorizationResponseProto_descriptor,
              new String[] { "ResponseCode", "UnauthorizedPaths", "ResponseMessage", });
          internal_static_com_cloudera_cloud_storage_signer_SignRequestProto_descriptor =
            getDescriptor().getMessageTypes().get(3);
          internal_static_com_cloudera_cloud_storage_signer_SignRequestProto_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_com_cloudera_cloud_storage_signer_SignRequestProto_descriptor,
              new String[] { "Endpoint", "HttpMethod", "Headers", "Parameters", "ContentToSign", "ResourcePath", "TimeOffset", "EndpointPrefix", "ServiceName", });
          internal_static_com_cloudera_cloud_storage_signer_SignResponseProto_descriptor =
            getDescriptor().getMessageTypes().get(4);
          internal_static_com_cloudera_cloud_storage_signer_SignResponseProto_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_com_cloudera_cloud_storage_signer_SignResponseProto_descriptor,
              new String[] { "AuthorizationResponse", "SignerGeneratedHeaders", "Region", });
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }

  // @@protoc_insertion_point(outer_class_scope)
}
